//ZaciSa's Last Stand
function Render()
{
	this.refreshRate = 17; this.refreshLastCall; this.refreshHandle; this.isRendering = false;
	this.renderCanvas; this.tvCanvas; this.gp0Canvas;
	//this.renderContext; this.renderWidth = 1024; this.renderHeight = 576;
	this.renderContext; this.renderWidth = 1280; this.renderHeight = 720;
	//this.renderContext; this.renderWidth = 1920; this.renderHeight = 1080;
	this.tvContext; this.tvWidth = this.renderWidth; this.tvHeight = this.renderHeight;
	this.gp0Context; this.gp0Width = 854; this.gp0Height = 480;
	//this.timerCustom = {};
	this.renderControl = null;
	this.gp0RenderRatio = 0.6;
	this.gp0RenderRatioMax = 0.7; this.gp0RenderRatioMin = 0.42;
	
	this.renderTVRatio = 1280.0/1920.0; //*Render.renderTVRatio
	this.trueWidth = 1920; this.trueHeight = 1080;
	
	this.renderMaster = {};
	
	this.images = {}; this.imageGroups = {};
	this.sounds = {}; this.soundGroups = {};
	this.soundMusicVolume = 0.8; this.soundEtcVolume = 0.5;
	
	this.act; this.actCanMiiverse = false; this.actCanInternet = false;
	this.actCanMiiverseShow = false;
	this.actIsOnline = true;
	
	//Debug Controls
	this.renderTime = 0; this.renderClicks = 0; this.renderStats = 0;
	this.refreshTimer = []; this.refreshLastTime = 0;
	this.renderGP0TV = false; this.renderGP0TVPossible = false;
	this.memoryManagementHandle = null;
	this.renderGP0TVOnly = false;
	//this.drawImageCount = 0; this.drawImageCountAmts = []; this.drawImageCountMax = 60;
	//this.drawImageSRCs = [];
	
	this.init = function()
	{
		//this.renderCanvas = document.getElementById("renderCanvas");
		this.gp0Canvas = document.getElementById("gp0Canvas");
		if (!this.renderGP0TVOnly)
		{
			if (tvDisplay == undefined) this.tvCanvas = document.getElementById("tvCanvas");
			else this.tvCanvas = tvDisplay.window.document.getElementById("tvCanvas");
		} else this.tvCanvas = this.gp0Canvas;
		//this.renderContext = this.renderCanvas.getContext("2d");
		this.gp0Context = this.gp0Canvas.getContext("2d");
		this.tvContext = this.tvCanvas.getContext("2d");
		
		if (tvDisplay != undefined)
		{
			this.tvWidth = tvDisplay.width; this.tvHeight = tvDisplay.height;
		}
		
		//this.renderCanvas.width = this.renderWidth; this.renderCanvas.height = this.renderHeight;
		this.tvCanvas.width = this.tvWidth; this.tvCanvas.height = this.tvHeight;
		this.gp0Canvas.width = this.gp0Width; this.gp0Canvas.height = this.gp0Height;
		
		//GamePad/TV Canvases
		$(".canvas").each(function()
		{
			this.width = Render.gp0Width;
			this.height = Render.gp0Height;
		});
		if (tvDisplay != undefined)
		{
			$(tvDisplay.window.document).find(".canvas").each(function()
			{
				this.width = Render.tvWidth;
				this.height = Render.tvHeight;
			});
		}
		
		//drawImage Counts
		/*var orig_drawImage = CanvasRenderingContext2D.prototype.drawImage;
		CanvasRenderingContext2D.prototype.drawImage = function()
		{
			if (Render.renderTime) Render.drawImageCount++;
			if (Render.renderTime) Render.drawImageSRCs.push(arguments[0]);
			orig_drawImage.apply(this, arguments);
		};
		tvDisplay.window.CanvasRenderingContext2D.prototype.drawImage = function()
		{
			if (Render.renderTime) Render.drawImageCount++;
			if (Render.renderTime) Render.drawImageSRCs.push(arguments[0]);
			orig_drawImage.apply(this, arguments);
		};*/
		
		//Defaults
		this.tvContext.textAlign = "left";
		this.tvContext.textBaseline = "top";
		this.gp0Context.textAlign = "left";
		this.gp0Context.textBaseline = "top";
		
		//Main Account
		this.act = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
		this.actCanMiiverse = this.act.miiverseRestrictionLevel == nwf.act.NintendoAccount.RESTRICTION_NONE;
		this.actCanInternet = this.act.networkCommunicationAllowed;
		//this.actCanMiiverseShow = true;
		
		//Make sure doesn't try to auto-connect
		var net = nwf.net.Network.getInstance();
		net.addEventListener(nwf.events.NetworkEvent.CONNECTED, function()
		{
			Render.actIsOnline = true;
			DialogConnectOnline.connectedSuccess();
		}, this);
		net.addEventListener(nwf.events.NetworkEvent.DISCONNECTED, function()
		{
			Render.actIsOnline = false;
		}, this);
		net.addEventListener(nwf.events.NetworkEvent.FAILED_TO_CONNECT, function()
		{
			Render.actIsOnline = false;
			DialogConnectOnline.connectedFail();
			nwf.net.Network.workOffline();
		}, this);
		
		//Render Loop
		function _loop()
		{
			//if (Render.isRendering) return false;
			//var nowtime = Date.now();
			if (Render.renderTime && Render.refreshLastTime)
			{
				var nowtime = Date.now();
				Render.refreshTimer.push(nowtime-Render.refreshLastTime);
				while(Render.refreshTimer.length > 60)
					Render.refreshTimer.shift();
			}
			
			//if (nowtime - Render.refreshLastCall >= Render.refreshRate)
			//{
			//Render.isRendering = true;
			//Render.refreshLastCall = nowtime;
			Render.renderToScreen();
			//Render.isRendering = false;
			//}
			
			if (Render.renderTime)
			{
				nowtime = Date.now();
				Render.refreshLastTime = nowtime;
			}
			
			window.webkitRequestAnimationFrame(_loop);
			
			return true;
			var msTime = Date.now() - Render.refreshLastCall;
			if (msTime >= Render.refreshRate) _loop();
			else this.refreshHandle = setTimeout(_loop, Math.floor(Render.refreshRate-msTime));
		};
		this.refreshLastCall = 0;
		window.webkitRequestAnimationFrame(_loop);
		
		//this.startMemoryManagementHandle();

		ClickBank.init();
		InputBank.init();
		SplashScreen.init();
		
		setInterval(function()
		{
			ClickBank.clickHeld();
			InputBank.pressReleaseCheck();
		}, 10);
	};

	//Memory Management
	this.startMemoryManagementHandle = function()
	{
		var lastmemoryrequest=0;
		clearInterval(this.memoryManagementHandle);
		this.memoryManagementHandle = setInterval(function()
		{
			var stats = nwf.system.Memory.getMemoryStats();
			if (lastmemoryrequest+120000 < Date.now()
				&& (stats.usedMemory > 750*1028*1028 || stats.jscDefaultFreeMemory <= 1*1024*1024 || stats.wkDefaultFreeMemory < 15*1024*1024))
			{
				//console.log("Requesting GC", nwf.system.Memory.getMemoryStats());
				nwf.system.Memory.requestGC();
				//lastmemoryrequest = Date.now();
			}
		}, 30000);
	};
	this.stopMemoryManagementHandle = function()
	{
		clearInterval(this.memoryManagementHandle);
	};
	
	
	//Retrun the heap free amount
	this.getHeapFree = function()
	{
		var stat = nwf.system.Memory.getMemoryStats();
		var amt = stat.jscDefaultFreeMemory;
		stat = null;
		nwf.system.Memory.requestGC();
		return amt;
	};
	
	//Does main rendering and output to Gamepad and TV
	this.renderLastAmt = 0;
	this.renderToScreen = function()
	{
		var t = Date.now();
		//if (Render.renderTime) Render.drawImageCount = 0;
		//if (Render.renderTime) Render.drawImageSRCs = [];
		
		//Lag Check
		if (this.renderLastAmt >= 30) Game.isLagging2 = true;
		else Game.isLagging2 = false;
		
		//Render the stuff on the behind the scenes render canvis
		if (this.renderControl) this.renderControl();
		
		//GP0 TV Render?
		//if (this.renderGP0TV) this.tvContext.drawImage(this.gp0Canvas, 0, 0);//, this.tvWidth, this.tvHeight);
		/*if (this.renderGP0TVPossible)
		{
			if (this.renderGP0TV)
			{
				$(tvDisplay.window.document).find("#tvCanvas").hide();
				$(tvDisplay.window.document).find("#gp0CanvasTV").show();
				var cxt = tvDisplay.window.document.getElementById("gp0CanvasTV").getContext("2d");
				cxt.drawImage(this.gp0Canvas, 0, 0, this.tvWidth, this.tvHeight);
			} else {
				$(tvDisplay.window.document).find("#tvCanvas").show();
				$(tvDisplay.window.document).find("#gp0CanvasTV").hide();
			}
		}*/
		
		//Lag Check
		this.renderLastAmt = (Date.now() - t);
		
		//Show Memory Stats - Warning: Heap will go down
		if (this.renderStats)
		{
			if (this.memoryStats == undefined || this.memoryStats == null || this.memoryStatsTime+250<Date.now())
			{
				this.memoryStats = nwf.system.Memory.getMemoryStats();
				this.memoryStatsTime = Date.now();
			}
			var stats = this.memoryStats;//nwf.system.Memory.getMemoryStats();
			var freeMem = "", memStat = "KB";
			var text = "";
			freeMem = stats.freeGraphicsMemory/1024; memStat = "KB";
			if (freeMem > 1024)
			{
				freeMem = freeMem/1024;
				memStat = "MB";
			}
			text += freeMem.toFixed(2)+memStat+" Graphics | ";
			/*freeMem = stats.jscCodeFreeMemory/1024; memStat = "KB";
			if (freeMem > 1024)
			{
				freeMem = freeMem/1024;
				memStat = "MB";
			}
			text += freeMem.toFixed(2)+memStat+" Code | ";*/
			freeMem = stats.jscDefaultFreeMemory/1024; memStat = "KB";
			if (freeMem > 1024)
			{
				freeMem = freeMem/1024;
				memStat = "MB";
			}
			text += freeMem.toFixed(2)+memStat+" Heap | ";
			freeMem = stats.jscRegisterFreeMemory/1024; memStat = "KB";
			if (freeMem > 1024)
			{
				freeMem = freeMem/1024;
				memStat = "MB";
			}
			text += freeMem.toFixed(2)+memStat+" Register | ";
			freeMem = stats.wkDefaultFreeMemory/1024; memStat = "KB";
			if (freeMem > 1024)
			{
				freeMem = freeMem/1024;
				memStat = "MB";
			}
			text += freeMem.toFixed(2)+memStat+" Webkit | ";
			freeMem = stats.freeMemory/1024; memStat = "KB";
			if (freeMem > 1024)
			{
				freeMem = freeMem/1024;
				memStat = "MB";
			}
			text += freeMem.toFixed(2)+memStat+" Free";

			this.tvContext.textAlign = "center";
			this.tvContext.font = "24px Verdana";
			this.tvContext.fillStyle = "#000";
			this.tvContext.fillRect(0, Render.tvHeight-40, Render.tvWidth, 40);
			this.tvContext.fillStyle = "#FFF";
			this.tvContext.fillText(text, Render.tvWidth/2, Render.tvHeight-35);
			this.tvContext.textAlign = "left";
			
			this.gp0Context.textAlign = "center";
			this.gp0Context.font = "12px Verdana";
			this.gp0Context.fillStyle = "#000";
			this.gp0Context.fillRect(0, Render.gp0Height-30, Render.gp0Width, 30);
			this.gp0Context.fillStyle = "#FFF";
			this.gp0Context.fillText(text, Render.gp0Width/2, Render.gp0Height-25);
			this.gp0Context.textAlign = "left";
		}
		
		//Monitor the time it takes to render
		if (this.renderTime)
		{
			if (this.tClock == undefined) this.tClock = [];
			this.tClock[this.tClock.length] = (Date.now() - t);
			if (this.tClock.length > 20) this.tClock.shift();
			var tClockSum = 0;
			//for(var key in this.tClock)
			var i = this.tClock.length-1;
			if (i >= 0)
			do
			{
				tClockSum += this.tClock[i];
			} while(i--);
			
			//if (this.tClock.length > 10)
				//this.changeRenderRate(Math.ceil(tClockSum / this.tClock.length));
			
			//Draw Image Counts
			//this.drawImageCount = 0; this.drawImageCountAmts = []; this.drawImageCountMax = 60;
			//this.drawImageCountAmts.push(this.drawImageCount);
			//if (this.drawImageCountAmts.length > this.drawImageCountMax) this.drawImageCountAmts.shift();
			var ImageCountSum = 0;
			//for(var key in this.drawImageCountAmts)
				//ImageCountSum += this.drawImageCountAmts[key];
			
			var refreshRate = 0;
			//for(var key in this.refreshTimer)
			var i = this.refreshTimer.length-1;
			if (i >= 0)
			do
			{
				refreshRate += this.refreshTimer[i];
			} while(i--);
			refreshRate = refreshRate / this.refreshTimer.length;

			this.tvContext.textAlign = "left";
			this.tvContext.font = "20px Verdana";
			this.tvContext.fillStyle = "#000";
			this.tvContext.fillRect(0, 0, 200, 40);
			this.tvContext.fillStyle = "#FFF";
			this.tvContext.fillText(Math.round(tClockSum / this.tClock.length)+" | "+refreshRate.toFixed(1)+" = "+(Date.now() - t), 5, 5);
			//this.tvContext.fillText(Math.round(ImageCountSum / this.drawImageCountAmts.length)+" | "+this.drawImageCount, 5, 35);

			this.gp0Context.textAlign = "left";
			this.gp0Context.font = "20px Verdana";
			this.gp0Context.fillStyle = "#000";
			this.gp0Context.fillRect(0, 200, 200, 40);
			this.gp0Context.fillStyle = "#FFF";
			this.gp0Context.fillText(Math.round(tClockSum / this.tClock.length)+" | "+refreshRate.toFixed(1)+" = "+(Date.now() - t), 5, 205);
			//this.gp0Context.fillText(Math.round(ImageCountSum / this.drawImageCountAmts.length)+" | "+this.drawImageCount, 5, 230);
		}
		
		//Render Master
		for(var mID in this.renderMaster)
			this.renderMaster[mID]();
		
		//ClickBank.triggerDelayClicks();
		//if (this.renderClicks) ClickBank.render();
	};
	
	//Will adjust the render rate depending on the average time
	this.changeRenderRate = function(avgTime)
	{
		return false;
		if (avgTime <= 30) this.refreshRate = 33;
		else if (avgTime <= 40) this.refreshRate = 45;
		else if (avgTime <= 50) this.refreshRate = 55;
		else if (avgTime <= 55) this.refreshRate = 60;
		else this.refreshRate = 70;
	};
	
	//Clear render canvis area
	this.renderClear = function(type)
	{
		if (type == undefined) type = "all";
		
		if (type == "all" || type == "tv")
			this.tvContext.clearRect(0, 0, this.tvWidth, this.tvHeight);
		if (type == "all" || type == "gp0" || type == "gp")
			this.gp0Context.clearRect(0, 0, this.gp0Width, this.gp0Height);
	};
	
	//Overlay a render master for debug purposes only
	this.renderMasterAdd = function(id, func)
	{
		this.renderMaster[id] = func;
	};
	
	//Delete a render master
	this.renderMasterClear = function(id)
	{
		delete this.renderMaster[id];
	};
	
	//Delete all render masters
	this.renderMasterClear = function()
	{
		this.renderMaster = {};
	};
	
	this.returnTVSliceContext = function(index)
	{
		var canvas = tvDisplay.window.document.getElementById("tvCanvas"+index);
		if (canvas) return canvas.getContext("2d");
		
		return null;
	};
	
	this.GP0SliceCaches = {};
	this.returnGP0SliceContext = function(index)
	{
		if (this.GP0SliceCaches[index] != undefined)
		{
			return this.GP0SliceCaches[index];
		} else {
			var canvas = document.getElementById("gp0Canvas"+index);
			if (canvas)
			{
				this.GP0SliceCaches[index] = canvas.getContext("2d");
				return canvas.getContext("2d");
			}
		}
		
		return null;
	};
	
	//Gamepad Display Move Start
	this.gxts = [1,2,3,4,5,"5_d","5_2","5_2d",6,"7b",7,8,9];
	this.gp0DisplayMoveStart = function()
	{
		var baseX = GameGP0Display.baseX, baseY = GameGP0Display.baseY;
		
		Render.gp0Context.setTransform(1, 0, 0, 1, baseX, baseY);

		Render.returnGP0SliceContext(1).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(2).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(3).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(4).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(5).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext("5_d").setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext("5_2").setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext("5_2d").setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(6).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext("7b").setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(7).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(8).setTransform(1, 0, 0, 1, baseX, baseY);
		Render.returnGP0SliceContext(9).setTransform(1, 0, 0, 1, baseX, baseY);
		
		return false;
		for(var key in this.gxts)
		{
			gxt = Render.returnGP0SliceContext(this.gxts[key]);
			//gxt.save();
			//gxt.translate(GameGP0Display.baseX, GameGP0Display.baseY);
			gxt.setTransform(1, 0, 0, 1, GameGP0Display.baseX, GameGP0Display.baseY);
		}
		
		gxt = null;
	};
	
	//Gamepad Display Move End
	this.gp0DisplayMoveEnd = function()
	{
		return false;
		var gxt = Render.gp0Context;
		
		gxt.restore();
		
		for(var key in this.gxts)
		{
			gxt = Render.returnGP0SliceContext(this.gxts[key]);
			gxt.restore();
		}
	};
	
	
	//Add new image ID to a group
	this.imageAddGroup = function(ID, group)
	{
		
	};
	
	//Deletes an image from use
	this.imageDelete = function(ID)
	{
		
	};
	
	//Deletes an individual image in a group
	this.imageDeleteFromGroup = function(ID, group)
	{
		
	};
	
	//Deletes all images in a group
	this.imageDeleteAllFromGroup = function(group)
	{
		
	};

	
	//Add new Sound
	this.soundAdd = function(ID, src, lData, onReadyFunc)
	{
		audio = new Audio();
		audio.src = src;
		audio.data = lData.data;
		for(var type in lData.data)
			audio[type] = lData.data[type];
		if (onReadyFunc)
			audio.addEventListener("canplay", function()
			{
				onReadyFunc();
				
				this.removeEventListener("canplay", this);
			});
		
		//Apply Volume Control
		if (lData.group == "music")
			audio.volume = lData.data.volume * this.soundMusicVolume;
		else if (lData.group == "etc")
			audio.volume = lData.data.volume * this.soundEtcVolume;
		
		Render.sounds[ID] = audio;
	};
	
	//Add new sound ID to a group
	this.soundAddGroup = function(ID, group)
	{
		if (this.soundGroups[group] == undefined)
			this.soundGroups[group] = [];
		
		this.soundGroups[group].push(ID);
	};
	
	//Deletes an sound from use
	this.soundDelete = function(ID)
	{
		
	};
	
	//Deletes an individual sound in a group
	this.soundDeleteFromGroup = function(ID, group)
	{
		
	};
	
	//Deletes all sounds in a group
	this.soundDeleteAllFromGroup = function(group)
	{
		
	};
	
	//Apply a new volume control to the held sounds
	this.soundApplyNewVolume = function(volume, group)
	{
		if (group == undefined) group = null;
		
		var soundIDs = [];
		if (group)
		{
			for(var key in this.soundGroups[group])
				soundIDs.push(this.soundGroups[group][key]);
		} else {
			for(var key in this.sounds)
				soundIDs.push(this.sounds[key]);
		}
		var audio;
		for(var key in soundIDs)
		{
			audio = this.sounds[soundIDs[key]];
			audio.volume = audio.data.volume * volume;
		}
	};
	
	//Stop all possible playing sounds
	this.soundStopAll = this.soundsStopAll = function()
	{
		for(var ID in this.sounds)
		{
			this.sounds[ID].pause();
		}
	};
	
	
	//Common Render the Bases
	this.heartCycleIndex = 1; this.heartCycleIndexMax = 2;
	this.heartCycleTTL = 15; this.heartCycleTTLBase = 15;
	this.renderBases_cxtCache = []; this.renderBases_gxtCache = [];
	this.renderBases = function(canvasCache)
	{
		if (typeof canvasCache == "undefined") canvasCache = "7";
		
		var cxt, gxt;
		var heartCycleShow = false;
		
		//this.gameOver
		this.heartCycleTTL -= 1*(Game.gameOver ? 1/3 : 1)*(Game.fastEnabled && Game.fastRate == 5 ? 0.5 : 1);
		if (this.heartCycleTTL <= 0)
		{
			this.heartCycleTTL = this.heartCycleTTLBase;
			this.heartCycleIndex++;
			if (this.heartCycleIndex > this.heartCycleIndexMax) this.heartCycleIndex = 1;
			heartCycleShow = true;
		}
		
		//var cxtCache = []; //TV Canvas #7 Render
		//var gxtCache = []; //GP0 Canvas #7 Render
		var cxtCache = this.renderBases_cxtCache; cxtCache.length = 0;
		var gxtCache = this.renderBases_gxtCache; gxtCache.length = 0;
		
		//Render the Heart(s)
		var bases = Game.mapClass.base;
		var base, gp0Cord;
		//for(var key in Game.mapClass.base)
		baseIndex = bases.length-1;
		do
		{
			base = bases[baseIndex];
			if (base.life <= 0) continue;
			
			gp0Cord = Game.calculateGPCords(base.r, 0, true);
			base.r2 = gp0Cord.x2;
			gp0Cord = Game.calculateGPCords(base.x, base.y);
			base.x2 = gp0Cord.x2; base.y2 = gp0Cord.y2;
			var p = (base.life / base.maxLife).toFixed(2);
			
			if (base.cache == undefined) base.cache = {};
			//continue;
			
			cxtCache[cxtCache.length] = ({
				render: Game.renderBotsTV
					|| base.cache.hx == undefined || base.cache.hx != base.x
					|| base.cache.hy == undefined || base.cache.hy != base.y
					|| base.cache.hr == undefined || base.cache.hr != base.r
					|| base.cache.hp == undefined || base.cache.hp != p
					|| base.cache.shield == undefined || base.cache.shield != base.shield,
				func: "renderBases_cxtHeart",
				ID: baseIndex,
				data: {
					p: p
				}
			});
			
			gxtCache[gxtCache.length] = ({
				render: Game.renderBotsTV
					|| base.cache.hx == undefined || base.cache.hx != base.x
					|| base.cache.hy == undefined || base.cache.hy != base.y
					|| base.cache.hr == undefined || base.cache.hr != base.r
					|| base.cache.hp == undefined || base.cache.hp != p
					|| base.cache.shield == undefined || base.cache.shield != base.shield,
				func: "renderBases_gxtHeart",
				ID: baseIndex,
				data: {
					p: p
				}
			});
			
			base.cache.hx = base.x;
			base.cache.hy = base.y;
			base.cache.hr = base.r;
			base.cache.hp = p;
		} while(baseIndex--);
		
		//Render the Base(s)
		//for(var key in bases)
		var baseIndex = bases.length-1;
		do
		{
			base = bases[baseIndex];
			if (base.life <= 0) continue;
			
			gp0Cord = Game.calculateGPCords(base.r, 0, true);
			base.r2 = gp0Cord.x2;
			gp0Cord = Game.calculateGPCords(base.x, base.y);
			base.x2 = gp0Cord.x2; base.y2 = gp0Cord.y2;
			var p = (base.life / base.maxLife).toFixed(2);
			
			if (base.cache == undefined) base.cache = {};
			//continue;
			
			if (base.shield > 0)
			{
				cxtCache[cxtCache.length] = ({
					render: Game.renderBotsTV
						|| base.cache.x == undefined || base.cache.x != base.x
						|| base.cache.y == undefined || base.cache.y != base.y
						|| base.cache.r == undefined || base.cache.r != base.r
						|| base.cache.p == undefined || base.cache.p != p
						|| base.cache.shield == undefined || base.cache.shield != base.shield,
					func: "renderBases_cxtBaseShield",
					ID: baseIndex,
					data: {}
				});
				
				gxtCache[gxtCache.length] = ({
					render: Game.renderBotsTV
						|| base.cache.x == undefined || base.cache.x != base.x
						|| base.cache.y == undefined || base.cache.y != base.y
						|| base.cache.r == undefined || base.cache.r != base.r
						|| base.cache.p == undefined || base.cache.p != p
						|| base.cache.shield == undefined || base.cache.shield != base.shield,
					func: "renderBases_gxtBaseShield",
					ID: baseIndex,
					data: {}
				});
				
			} else {
				cxtCache[cxtCache.length] = ({
					render: Game.renderBotsTV
						|| base.cache.x == undefined || base.cache.x != base.x
						|| base.cache.y == undefined || base.cache.y != base.y
						|| base.cache.r == undefined || base.cache.r != base.r
						|| base.cache.p == undefined || base.cache.p != p
						|| base.cache.shield == undefined || base.cache.shield != base.shield,
					func: "renderBases_cxtBase",
					ID: baseIndex,
					data: {
						p: p
					}
				});
				
				gxtCache[gxtCache.length] = ({
					render: Game.renderBotsTV
						|| base.cache.x == undefined || base.cache.x != base.x
						|| base.cache.y == undefined || base.cache.y != base.y
						|| base.cache.r == undefined || base.cache.r != base.r
						|| base.cache.p == undefined || base.cache.p != p
						|| base.cache.shield == undefined || base.cache.shield != base.shield,
					func: "renderBases_gxtBase",
					ID: baseIndex,
					data: {
						p: p
					}
				});
			}
			base.cache.x = base.x;
			base.cache.y = base.y;
			base.cache.r = base.r;
			base.cache.p = p;
			base.cache.shield = base.shield;
		} while(baseIndex--);
		
		//TV Canvas #7
		var renderToTVCanvas7 = false;
		//for(var key in cxtCache)
		var cacheIndex = cxtCache.length-1;
		if (cacheIndex >= 0)
		{
			do {
				if (cxtCache[cacheIndex].render)
					renderToTVCanvas7 = true;
			} while(cacheIndex--);
		}
		if (Game.renderBotsTV || renderToTVCanvas7 || heartCycleShow)
		{
			cxt = Render.returnTVSliceContext(canvasCache);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			
			//for(var key in cxtCache)
			cacheIndex = cxtCache.length-1;
			if (cacheIndex >= 0)
			{
				do {
					//cxtCache[key].func(cxtCache[key].ID, cxtCache[key].data);
					Render[cxtCache[cacheIndex].func](cxt, cxtCache[cacheIndex].ID, cxtCache[cacheIndex].data);
				} while(cacheIndex--);
			}
			
			Game.renderBotsTV = true;
		}
		cxtCache.length = 0;
		//cxt = Render.tvContext;
		cxt = null;
		
		//GP0 Canvas #7
		var renderToGP0Canvas7 = false;
		//for(var key in gxtCache) if (gxtCache[key].render) renderToGP0Canvas7 = true;
		var cacheIndex = gxtCache.length-1;
		if (cacheIndex >= 0)
		{
			do {
				if (gxtCache[cacheIndex].render)
					renderToGP0Canvas7 = true;
			} while(cacheIndex--);
		}
		if (Game.renderBotsGP0 || renderToGP0Canvas7 || Game.resetGP0SliceCache || heartCycleShow)
		{
			gxt = Render.returnGP0SliceContext(canvasCache);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			
			//for(var key in gxtCache)
			cacheIndex = gxtCache.length-1;
			if (cacheIndex >= 0)
			{
				do {
					//gxtCache[key].func(gxtCache[key].ID, gxtCache[key].data);
					Render[gxtCache[cacheIndex].func](gxt, gxtCache[cacheIndex].ID, gxtCache[cacheIndex].data);
				} while(cacheIndex--);
			}
			
			Game.renderBotsGP0 = true;
		}
		gxtCache.length = 0;
		//gxt = Render.gp0Context;
		gxt = null;
		
		delete cxtCache;
		delete gxtCache;
	};
	
	this.renderBases_cxtBaseShield = function(cxt, ID, data)
	{
		var base = Game.mapClass.base[ID];
		
		cxt.drawImage(Render.images["base_blue"], (base.x-base.r)*Render.renderTVRatio, (base.y-base.r)*Render.renderTVRatio, base.r*2*Render.renderTVRatio, base.r*2*Render.renderTVRatio);
	};
	this.renderBases_gxtBaseShield = function(gxt, ID, data)
	{
		var base = Game.mapClass.base[ID];
		
		gxt.drawImage(Render.images["base_blue"], base.x2-base.r2, base.y2-base.r2, base.r2*2, base.r2*2);
	};
	this.renderBases_cxtBase = function(cxt, ID, data)
	{
		var base = Game.mapClass.base[ID];
		var p = data.p;
		
		cxt.drawImage(Render.images["base"], (base.x-base.r)*Render.renderTVRatio, (base.y-base.r)*Render.renderTVRatio, base.r*2*Render.renderTVRatio, base.r*2*Render.renderTVRatio);
		if (p < 1)
		{
			cxt.globalAlpha = 1-p;
			cxt.drawImage(Render.images["base_red"], (base.x-base.r)*Render.renderTVRatio, (base.y-base.r)*Render.renderTVRatio, base.r*2*Render.renderTVRatio, base.r*2*Render.renderTVRatio);
			cxt.globalAlpha = 1;
		}
	};
	this.renderBases_gxtBase = function(gxt, ID, data)
	{
		var base = Game.mapClass.base[ID];
		var p = data.p;
		
		gxt.drawImage(Render.images["base"], base.x2-base.r2, base.y2-base.r2, base.r2*2, base.r2*2);
		if (p < 1)
		{
			gxt.globalAlpha = 1-p;
			gxt.drawImage(Render.images["base_red"], base.x2-base.r2, base.y2-base.r2, base.r2*2, base.r2*2);
			gxt.globalAlpha = 1;
		}
	};
	this.renderBases_cxtHeart = function(cxt, ID, data)
	{
		var base = Game.mapClass.base[ID];
		var p = data.p;
		
		cxt.drawImage(Render.images["heart"+Render.heartCycleIndex], (base.x-base.r*Game.baseHeartPercent)*Render.renderTVRatio, (base.y-base.r*Game.baseHeartPercent)*Render.renderTVRatio, base.r*Game.baseHeartPercent*2*Render.renderTVRatio, base.r*Game.baseHeartPercent*2*Render.renderTVRatio);
		if (p < 1)
		{
			cxt.globalAlpha = 1-p;
			cxt.drawImage(Render.images["heart_dark"+Render.heartCycleIndex], (base.x-base.r*Game.baseHeartPercent)*Render.renderTVRatio, (base.y-base.r*Game.baseHeartPercent)*Render.renderTVRatio, base.r*Game.baseHeartPercent*2*Render.renderTVRatio, base.r*Game.baseHeartPercent*2*Render.renderTVRatio);
			cxt.globalAlpha = 1;
		}
	};
	this.renderBases_gxtHeart = function(gxt, ID, data)
	{
		var base = Game.mapClass.base[ID];
		var p = data.p;
		
		gxt.drawImage(Render.images["heart"+Render.heartCycleIndex], base.x2-base.r2*Game.baseHeartPercent, base.y2-base.r2*Game.baseHeartPercent, base.r2*Game.baseHeartPercent*2, base.r2*Game.baseHeartPercent*2);
		if (p < 1)
		{
			gxt.globalAlpha = 1-p;
			gxt.drawImage(Render.images["heart_dark"+Render.heartCycleIndex], base.x2-base.r2*Game.baseHeartPercent, base.y2-base.r2*Game.baseHeartPercent, base.r2*Game.baseHeartPercent*2, base.r2*Game.baseHeartPercent*2);
			gxt.globalAlpha = 1;
		}
	};
	
	
	//Generated a random id to return
	this.knownIDs = {};
	this.generateID = function(length)
	{
		if (length == undefined || length <= 0) length = 12;
		
		var ID = "", letters = "1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM";
		do
		{
			ID = "";
			for(var i=0; i<length; i++)
				ID += letters[Math.floor(Math.random()*letters.length)];
		} while(this.knownIDs[ID] != undefined);
		this.knownIDs[ID] = true;
		
		return ID;
	};
	this.clearGeneratedIDs = function()
	{
		this.knownIDs = {};
	};
	
	//Return the angle between two points
	this.determineAngle = function(x1, y1, x2, y2)
	{
		var angle = Math.atan((y2-y1) / (x2-x1)) * (180 / Math.PI);

		//Top Right
		if (x1 > x2 && y1 < y2) angle -= 90;
		//Bottom Right
		else if (x1 > x2 && y1 > y2) angle -= 90;
		//Bottom Left
		else if (x1 < x2 && y1 > y2) angle += 90;
		//Top Left
		else if (x1 < x2 && y1 < y2) angle += 90;
		
		//Top Center
		else if (((x1 - x2) < 0 ? -(x1 - x2) : (x1 - x2)) <= 1 && y1 < y2) angle = 180;
		//Bottom Center
		else if (((x1 - x2) < 0 ? -(x1 - x2) : (x1 - x2)) <= 1 && y1 > y2) angle = 0;
		//Left Middle
		else if (((y1 - y2) < 0 ? -(y1 - y2) : (y1 - y2)) <= 1 && x1 < x2) angle = 90;
		//Right Middle
		else if (((y1 - y2) < 0 ? -(y1 - y2) : (y1 - y2)) <= 1 && x1 > x2) angle = 270;
		
		return angle;
	};
	
	//Splits the text and returns it in an array
	this.splitText = function(ctx, text, width)
	{
		var rtr = [];
		
		text = text.split("\n");
		var line, words, word, x, w;
		for(var key in text)
		{
			line = text[key];
			if (ctx.measureText(line).width <= width) rtr.push(line);
			else {
				x = 0;
				words = line.split(" ");
				line = "";
				for(var key2 in words)
				{
					word = words[key2];
					if (word == "") continue;
					word = (line ? " " : "")+word;
					
					w = ctx.measureText(word).width;
					if (x + w > width)
					{
						rtr.push(line);
						x = 0;
						line = "";
						word = words[key2];
					}
					
					x += w;
					line += word;
				}
				if (line != "") rtr.push(line);
			}
		}
		while(rtr.length > 0 && rtr[0] == "") rtr.shift();
		while(rtr.length > 0 && rtr[rtr.length-1] == "") rtr.pop();
		
		return rtr;
	};
	
	//Updates the DOM to help clear up memory
	this.updateWebView = function()
	{
		$("#webviewupdate").text(Math.random());
	};
};
var Render = new Render();

//Dialog popup to connect online
function DialogConnectOnline()
{
	this.containerBG = null;
	this.container0 = null; this.container = null;
	this.successFunc = null;
	
	this.init = function(successFunc)
	{
		if (typeof successFunc == "undefined") successFunc = null;
		this.successFunc = successFunc;
		
		this.open();
	};
	
	this.open = function()
	{
		this.close();
		
		this.containerBG = $("<div style='position:absolute;left:0px;top:0px;width:100%;height:100%;z-index:1000000;background:#000;opacity:0.75;' />");
		this.container0 = $("<div style='position:absolute;left:50%;top:50%;width:600px;height:300px;margin-left:-300px;margin-top:-150px;z-index:1000001;background:URL(media/etc/popup.jpg);background-size:100% 100%;' />");
		this.container0.append("<div style='position:absolute;left:10px;top:10px;width:"+(this.container0.width()-20)+"px;height:"+(this.container0.height()-20)+"px;background:#000;opacity:0.88;' />");
		this.container = $("<div style='position:absolute;left:50%;top:50%;width:550px;height:250px;margin-left:-275px;margin-top:-125px;z-index:1000002;color:#FFF;' />");
		
		var w = 100, h = 26;
		var img_off = $("<img src='media/etc/button_grey.jpg' />");
		img_off.addClass("img_off").css({
			width: w+"px",
			height: h+"px",
			display: "none"
		});
		var img_on = $("<img src='media/etc/button2.jpg' />");
		img_on.addClass("img_on").css({
			width: w+"px",
			height: h+"px"
		});
		
		
		//Main
		var tab = $("<div class='tabs' tab='main' />");
		this.container.append(tab);
		var div = $("<div class='title' style='margin-bottom:35px;margin-top:-5px;font-size:36px;text-align:center;'>Connect Online?</div>");
		tab.append(div);
		
		var div = $("<div class='content' style='padding:0 10px;font-size:18px;'></div>");
		div.html("You are currently offline. Would you like to connect online?");
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			left: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Cancel</div>").click(function()
		{
			DialogConnectOnline.close();
		});
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			right: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Connect</div>").click(function()
		{
			DialogConnectOnline.connect();
		});
		tab.append(div);
		
		
		//Connecting
		var tab = $("<div class='tabs' tab='connecting' style='display:none;' />");
		this.container.append(tab);
		var div = $("<div class='title' style='margin-bottom:35px;margin-top:-5px;font-size:36px;text-align:center;'>Connecting...</div>");
		tab.append(div);
		
		var div = $("<div class='content' style='padding:0 10px;font-size:18px;'></div>");
		div.html("Attempting to connect online.");
		tab.append(div);
		
		
		//Failed
		var tab = $("<div class='tabs' tab='failed' style='display:none;' />");
		this.container.append(tab);
		var div = $("<div class='title' style='margin-bottom:35px;margin-top:-5px;font-size:36px;text-align:center;'>Could Not Connect Online</div>");
		tab.append(div);
		
		var div = $("<div class='content' style='padding:0 10px;font-size:18px;'></div>");
		div.html("Could not connect online.");
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			left: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Cancel</div>").click(function()
		{
			DialogConnectOnline.close();
		});
		tab.append(div);
		
		img_on = img_on.clone();
		img_off = img_off.clone();
		div = $("<div />");
		div.css({
			position: "absolute",
			right: "0px",
			bottom: "0px",
			width: w+"px",
			height: h+"px",
			"font-size": "16px",
			border: "1px solid #666",
			"text-align": "center"
		}).append(img_off).append(img_on)
		  .append("<div style='position:absolute;left:0px;top:2px;width:"+w+"px;'>Connect</div>").click(function()
		{
			DialogConnectOnline.connect();
		});
		tab.append(div);
		
		
		$("body").append(this.containerBG);
		$("body").append(this.container0);
		$("body").append(this.container);
	};
	
	this.close = function()
	{
		if (!this.container) return false;
		
		this.containerBG.remove();
		this.container0.remove();
		this.container.remove();
		this.container0 = null; this.container = null;
		this.successFunc = null;
	};
	
	this.switchTab = function(tab)
	{
		this.container.find(".tabs").hide();
		this.container.find(".tabs[tab='"+tab+"']").show();
	};
	
	this.connectedSuccess = function()
	{
		if (!this.container) return false;
		
		if (this.successFunc) this.successFunc();
		this.close();
	};
	
	this.connectedFail = function()
	{
		if (!this.container) return false;
		
		this.switchTab("failed");
	};
	
	this.connect = function()
	{
		this.switchTab("connecting");
		
		if (!nwf.net.Network.isConnected())
			nwf.net.Network.reconnect();
		else
			this.connectedSuccess();
	};
};
var DialogConnectOnline = new DialogConnectOnline();