function SplashScreen()
{
	//Version is Internal version, not Game version - Only used to indicate new stuff to edit/etc
	this.version = 1.19; this.setupData = {}; this.isSettingUp = false;
	this.timecounter; this.timelastcall;
	this.gameVersion = 1.3; //Offical Release/Lotcheck 1.3
	this.europeVerion = 1.01; //Offical Release/Lotcheck 1.0
	this.regionVersion = "Europe"; //NA|Europe
	
	this.NATitle = "ZaciSa's Last Stand";
	this.EuropeTitle = "ZaciSa: Defense of the Crayon Dimension!";
	
	this.hasLoadedOtherScripts = false;
	this.loadedScripts = {};
	
	this.images = {};
	
	this.mediaLoaded = 0; this.mediaToLoad = 0;
	
	this.init = function()
	{
		//nwf.system.Memory.requestGC();
		ClickBank.clearAll();
		InputBank.clearAll();
		
		//this.images["wiiu"] = new Image();
		//this.images["wiiu"].src = "images/wiiu2.png";
		
		if (!this.hasLoadedOtherScripts)
		{
			this.hasLoadedOtherScripts = true;
			
			/*var scripts = [],
				script, _script;
			for(var key in scripts)
			{
				script = scripts[key];
				
				this.loadedScripts[script] = false;
				_script = $(document.createElement("script"));
				_script.attr({
					src: "js/"+script+".js",
					type: "text/javascript",
					myname: script
				});
				$("head").append(_script);
			}*/
			
			//Media to load
			var path = "media/", img;
			var list = {
				"space1": "background/space1.jpg", "zacisa_title": "text/zacisa_title2.png",
				"zacisa_title_europe": "text/zacisa_title_europe.png", "zacisa_title_europe2": "text/zacisa_title_europe2.png",
				/*"challenges_title": "text/challenges_title.png",*/
				"button1": "etc/button1.jpg", "button2": "etc/button2.jpg", "button_grey": "etc/button_grey.jpg",
				"arrow1": "etc/arrow1.png", "arrow2": "etc/arrow2.png"//,
				/*"particle_red": "etc/particle_red.png", "particle_yellow": "etc/particle_yellow.png",
				"particle_grey": "etc/particle_grey.png", "particle_white": "etc/particle_white.png"*/
			};
			for(var ID in list)
			{
				this.mediaToLoad++;
				
				//unset onload
				if (Render.images[ID] == undefined)
				{
					function onImgLoad()
					{
						this.loaded = true;
						SplashScreen.mediaLoaded++;
						
						this.removeEventListener("onload", onImgLoad);
					};
					
					img = new Image();
					img.loaded = false;
					img.onload = onImgLoad;
					img.src = path+list[ID];
					Render.images[ID] = img;
				} else this.mediaLoaded++;
			}
			//$("#debug").append("3<br/>");
			
			//Audio to load
			var path = "audio/", audio, lData;
			var list = {
				"mainmenu": {
					src: "mainmenu.ogg",
					data: {
						volume: 1,
						gamepad1Volume: 1,
						tvVolume: 1,
						loop: true,
						auto: "auto"
					},
					group: "music"
				}
			};
			for(var ID in list)
			{
				lData = list[ID];
				this.mediaToLoad++;
				
				if (Render.sounds[ID] == undefined)
				{
					Render.soundAdd(ID, path+lData.src, lData);
					Render.soundAddGroup(ID, lData.group);
					this.mediaLoaded++;
				} else this.mediaLoaded++;
			}
			
			//Setup
			this.isSettingUp = true;
			setTimeout(function()
			{
				SplashScreen.setup();
			}, 250);
		}
		
		this.timecounter = 0;
		this.timelastcall = Date.now();
		
		Render.renderControl = function(){ SplashScreen.render(); };
	};
	
	this.render = function()
	{
		var deltatime = Date.now() - this.timelastcall;
		this.timelastcall += deltatime;
		this.timecounter += deltatime;
		/*if (!(Render.images["space1"].loaded && Render.images["zenfaproductions"].loaded))
		{
			this.timecounter = 0;
			
			//Clear
			Render.renderClear("all");
			var cxt = Render.tvContext, gxt = Render.gp0Context;
			
			//Black Background
			cxt.fillStyle = "000";
			cxt.fillRect(0, 0, Render.renderWidth, Render.renderHeight);
			gxt.fillStyle = "#000";
			gxt.fillRect(0, 0, Render.renderWidth, Render.renderHeight);

			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
			
			return true;
		}*/
		
		
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;

		//Background
		/*cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;*/
		
		
		//Where are you?
		if (this.timecounter < 6000 && 0)
		{
			var w = Render.tvWidth*0.75, h = w*(248/500);
			var x = Render.tvWidth/2 - w/2, y = Render.tvHeight/2 - h/2;
			
			cxt.drawImage(esrb, x, y, w, h);
			
			if (!esrb.isLoaded) this.timecounter = 0;
		} else if (this.timecounter <= 100000 && 0) {
			/*cxt.textAlign = "center";
			
			cxt.fillStyle = "#FFF";
			cxt.font = "125px Verdana";
			cxt.strokeStyle = "#000";
			var w = 1400, h = w*(246/2682);
			cxt.drawImage(Render.images["zacisa_title"], Render.tvWidth/2-w/2, 15, w, h);
			//cxt.strokeText("ZaciSa's Last Stand", Render.tvWidth/2, 15);

			var w = 1000, h = w*(254/2689);
			cxt.drawImage(Render.images["zenfaproductions"], Render.tvWidth/2-w/2, 250, w, h);
			//cxt.strokeText("ZeNfA Productions", Render.tvWidth/2, 250);

			cxt.font = "110px Verdana";
			cxt.fillText("Coming Soon", Render.tvWidth/2, 425);
			
			var w = 1000, h = w*(50/588);
			cxt.drawImage(this.images["wiiu"], Render.tvWidth/2-w/2, 750, w, h);

			cxt.font = "32px Verdana";
			cxt.fillText("ZaciSa's Last Stand copyright 2013 ZeNfA Productions LLC. All Rights Reserved.", Render.tvWidth/2, 960);
			cxt.fillText("Nintendo trademarks and copyrights are property of Nintendo. Wii U is a trademark of Nintendo. Copyright 2012 Nintendo.", Render.tvWidth/2, 1000);
			
			cxt.textAlign = "left";*/
			cxt.drawImage(this.images["wiiu"], 0, 0, Render.tvWidth, Render.tvHeight);
		} else if ((this.timecounter < 2500 && 1) || (this.isSettingUp && 0) || this.mediaLoaded != this.mediaToLoad) {
			//$("#debug2").html(Date.now());
			/*var x = Render.tvWidth/2, y = Render.tvHeight/2, fontSize = 125;
			cxt.fillStyle = "#FFF";
			cxt.textAlign = "center";
			cxt.font = fontSize+"px Verdana";
			cxt.fillText("ZeNfA Productions", x/*+100, y-fontSize/2);
			cxt.textAlign = "left";
			//cxt.drawImage(this.images["logo"], 275, y-90, 250, 250*.85);

			x = Render.gp0Width/2, y = Render.gp0Height/2, fontSize = 75;
			gxt.fillStyle = "#FFF";
			gxt.textAlign = "center";
			gxt.font = fontSize+"px Verdana";
			gxt.fillText("ZeNfA Productions", x/*+75, y-fontSize/2);
			gxt.textAlign = "left";*/
			//gxt.drawImage(this.images["logo"], 100, y-40, 125, 125*.85);
			
			var w = 1350, h = w*(254/2689);
			//cxt.drawImage(Render.images["zenfaproductions"], Render.tvWidth/2-w/2, Render.tvHeight/2-h/2, w, h);
			
			var w = 700, h = w*(254/2689);
			//gxt.drawImage(Render.images["zenfaproductions"], Render.gp0Width/2-w/2, Render.gp0Height/2-h/2, w, h);
			
		//End
		} else {
			this.finish();
		}
	};
	
	//Splash Screen Finish function
	this.finish = function()
	{
		if (this.loadedScripts["mainmenu"] || 1)
		{
			MainMenu.init();
			$(tvDisplay.window.document).find("#splashscreen").hide();
			$(tvDisplay.window.document).find(".canvas").show();
			$("#splashscreen").hide();
			$(".canvas").show();
			$("#gp0Canvas").show();
		}
	};
	
	
	//Initial Setup
	this.setup = function()
	{
		//this.setup_createSetup(); return false;
		if (FileIO.fileExists("setup.txt"))
		{
			//$("#debug").append("2-0<br/>");
			this.setup_readSetup();
		} else {
			//$("#debug").append("2<br/>");
			this.setup_createSetup();
		}
	};
	
	//Create Setup File
	this.setup_createSetup = function()
	{
		var langArray = {1: "english", 2: "french", 3: "german", 4: "italian", 5: "spanish"};
		var sysLang = nwf.system.WiiUSystem.getInstance().languageCode;
		var useLang = langArray[sysLang] ? langArray[sysLang] : "english";
		if (this.regionVersion == "NA") useLang = "english";
		
		var data = {
			version: SplashScreen.version,
			maps: ["ss001", "ams6", "hyperspace", "moonbase", "nebula", "circle", "twin", "ams2", "ping15plus", "bdu", "gaf", "pollux"],
			offlineScores: {"": ""},
			topScores: {"": ""},
			uploadedCommons: {"": ""},
			lang: useLang
		};
		this.setupData = data;
		
		Language.setLanguage(useLang);
		
		//$("#debug").append("3<br/>");
		FileIO.saveFile("setup.txt", data, function()
		{
			//$("#debug").append("4-1<br/>");
			SplashScreen.setup_createLeaderboard(true);
		}, function()
		{
			//$("#debug").append("4-2<br/>");
			SplashScreen.isSettingUp = false;
		});
	};
	
	//Read Setup File to make sure we have correct info
	this.setup_readSetup = function()
	{
		FileIO.readFile("setup.txt", function(data)
		{
			SplashScreen.setupData = data;
			if (SplashScreen.setupData.version != SplashScreen.version)
			{
				SplashScreen.setupData.version = SplashScreen.version;
				SplashScreen.setupData.maps = ["ss001", "ams6", "hyperspace", "moonbase", "nebula", "circle", "twin", "ams2", "ping15plus", "bdu", "gaf", "pollux"];
				if (typeof SplashScreen.setupData.offlineScores == "undefined")
					SplashScreen.setupData.offlineScores = {"": ""};
				if (typeof SplashScreen.setupData.topScores == "undefined")
					SplashScreen.setupData.topScores = {"": ""};
				if (typeof SplashScreen.setupData.uploadedCommons == "undefined")
					SplashScreen.setupData.uploadedCommons = {"": ""};
				if (typeof SplashScreen.setupData.lang == "undefined")
				{
					var langArray = {1: "english", 2: "french", 3: "german", 4: "italian", 5: "spanish"};
					var sysLang = nwf.system.WiiUSystem.getInstance().languageCode;
					var useLang = langArray[sysLang] ? langArray[sysLang] : "english";
					if (SplashScreen.regionVersion == "NA") useLang = "english";
					
					SplashScreen.setupData.lang = useLang;
				}
				if (SplashScreen.regionVersion == "NA") SplashScreen.setupData.lang = "english";
				
				Language.setLanguage(SplashScreen.setupData.lang);
				
				FileIO.saveFile("setup.txt", SplashScreen.setupData, function()
				{
					
				}, function()
				{
					SplashScreen.isSettingUp = false;
				});
				
				SplashScreen.setup_createLeaderboard(false);
			} else {
				if (typeof SplashScreen.setupData == "undefined") SplashScreen.setupData = {};
				if (typeof SplashScreen.setupData.offlineScores == "undefined")
					SplashScreen.setupData.offlineScores = {"": ""};
				if (typeof SplashScreen.setupData.topScores == "undefined")
					SplashScreen.setupData.topScores = {"": ""};
				if (typeof SplashScreen.setupData.uploadedCommons == "undefined")
					SplashScreen.setupData.uploadedCommons = {"": ""};
				if (typeof SplashScreen.setupData.lang == "undefined")
				{
					var langArray = {1: "english", 2: "french", 3: "german", 4: "italian", 5: "spanish"};
					var sysLang = nwf.system.WiiUSystem.getInstance().languageCode;
					var useLang = langArray[sysLang] ? langArray[sysLang] : "english";
					if (SplashScreen.regionVersion == "NA") useLang = "english";
					
					SplashScreen.setupData.lang = useLang;
				}
				if (SplashScreen.regionVersion == "NA") SplashScreen.setupData.lang = "english";
				
				Language.setLanguage(SplashScreen.setupData.lang);
				
				SplashScreen.setup_loadLeaderboardAndSave();
				SplashScreen.isSettingUp = false;
			}
		}, function()
		{
			SplashScreen.isSettingUp = false;
		});
	};
	
	//Creates the Leaderboard save file
	this.setup_createLeaderboard = function(isNew)
	{
		var rankings = [{name: "GWW", score: 100000},
		                {name: "ZNA", score: 90000},
		                {name: "MIE", score: 80000},
		                {name: "RLC", score: 70000},
		                {name: "SJB", score: 60000},
		                {name: "JER", score: 50000},
		                {name: "AMY", score: 40000},
		                {name: "CAT", score: 30000},
		                {name: "EA ", score: 20000},
		                {name: "PR ", score: 10000}];
		
		if (isNew)
		{
			var data = {};
			var modes = ["hard", "easy", "insanity", "endless"], mode;
			var maps = this.setupData.maps, map;
			for(var key in maps)
			{
				map = maps[key];
				data[map] = {};
				
				for(var key2 in modes)
				{
					mode = modes[key2];
					data[map][mode] = rankings.slice();
					//data[map][mode+"_online"] = 1;
				}
			}
			
			FileIO.saveFile("leaderboard.txt", data);
			this.setup_loadLeaderboardAndSave(data);
			this.isSettingUp = false;
		} else {
			FileIO.readFile("leaderboard.txt", function(data)
			{
				var modes = ["hard", "easy", "insanity", "endless"], mode;
				var maps = SplashScreen.setupData.maps, map;
				for(var key in maps)
				{
					map = maps[key];
					if (data[map] == undefined) data[map] = {};
					
					for(var key2 in modes)
					{
						mode = modes[key2];
						if (data[map][mode] == undefined)
							data[map][mode] = rankings.slice();
						//if (data[map][mode+"_online"] == undefined)
							//data[map][mode+"_online"] = 1;
					}
				}
				
				FileIO.saveFile("leaderboard.txt", data);
				SplashScreen.setup_loadLeaderboardAndSave(data);
				SplashScreen.isSettingUp = false;
			}, function()
			{
				SplashScreen.isSettingUp = false;
			});
		}
	};
	
	//Loads and saves the leaderboard data into the Leaderboard class
	this.setup_loadLeaderboardAndSave = function(data)
	{
		if (data == undefined)
		{
			FileIO.readFile("leaderboard.txt", function(data)
			{
				SplashScreen.setup_loadLeaderboardAndSave(data);
			}, function()
			{
				SplashScreen.isSettingUp = false;
			});
			return false;
		}
		
		if (typeof Leaderboard == "undefined")
		{
			setTimeout(function()
			{
				SplashScreen.setup_loadLeaderboardAndSave(data);
			}, 100);
			return false;
		}
		
		Leaderboard.scores = data;
	};
};
var SplashScreen = new SplashScreen();