function Credits()
{
	//Init
	this.init = function(area, map)
	{
		ClickBank.clearAll();
		InputBank.clearAll();
		
		Render.renderControl = function(){ Credits.render(); };
		
		
		//Buttons
		InputBank.add({
			id: "button",
			type: ["b"],
			action: function(clickID, vaultEntry, type)
			{
				switch(type)
				{
				case "b":
					MainMenu.init();
				break;
				}
			}
		});
	};
	
	//Render Function
	this.render = function()
	{
		var cxt = Render.renderContext;
		
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Background
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
		gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
		cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
		gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		
		
		cxt.fillStyle = "#FFF";
		cxt.textAlign = "center";
		gxt.fillStyle = "#FFF";
		gxt.textAlign = "center";
		
		cxt.font = "65px Verdana";
		gxt.font = "45px Verdana";
		var title = SplashScreen.NATitle;
		if (SplashScreen.regionVersion == "Europe")
		{
			cxt.font = "60px Verdana";
			gxt.font = "40px Verdana";
			title = SplashScreen.EuropeTitle;
		}
		var y = 10*Render.renderTVRatio, y2=0;
		cxt.fillText(title, Render.tvWidth/2, y);
		gxt.fillText(title, Render.gp0Width/2, y2);
		
		y += 140*Render.renderTVRatio; y2 += 70;
		cxt.font = "35px Verdana";
		cxt.fillText("~ "+_t("By")+" ~", Render.tvWidth/2, y);
		gxt.font = "25px Verdana";
		gxt.fillText("~ "+_t("By")+" ~", Render.gp0Width/2, y2);
		y += 70*Render.renderTVRatio; y2 += 30;
		cxt.font = "40px Verdana";
		cxt.fillText("ZeNfA Productions LLC", Render.tvWidth/2, y);
		gxt.font = "30px Verdana";
		gxt.fillText("ZeNfA Productions LLC", Render.gp0Width/2, y2);
		
		y += 140*Render.renderTVRatio; y2 += 60;
		cxt.font = "35px Verdana";
		cxt.fillText("~ "+_t("Programmer/Graphics")+" ~", Render.tvWidth/2, y);
		gxt.font = "25px Verdana";
		gxt.fillText("~ "+_t("Programmer/Graphics")+" ~", Render.gp0Width/2, y2);
		y += 70*Render.renderTVRatio; y2 += 30;
		cxt.font = "40px Verdana";
		cxt.fillText("Greg Wiggleton", Render.tvWidth/2, y);
		gxt.font = "30px Verdana";
		gxt.fillText("Greg Wiggleton", Render.gp0Width/2, y2);
		
		y += 140*Render.renderTVRatio; y2 += 60;
		cxt.font = "35px Verdana";
		cxt.fillText("~ "+_t("Music")+" ~", Render.tvWidth*0.25, y);
		cxt.fillText("~ "+_t("Artwork/Graphics")+" ~", Render.tvWidth*0.75, y);
		gxt.font = "25px Verdana";
		gxt.fillText("~ "+_t("Music")+" ~", Render.gp0Width*0.25, y2);
		gxt.fillText("~ "+_t("Artwork/Graphics")+" ~", Render.gp0Width*0.75, y2);
		y += 70*Render.renderTVRatio; y2 += 30;
		cxt.font = "40px Verdana";
		cxt.fillText("nosoapradio", Render.tvWidth*0.25, y);
		cxt.fillText("Cameron Perry", Render.tvWidth*0.75, y);
		gxt.font = "30px Verdana";
		gxt.fillText("nosoapradio", Render.gp0Width*0.25, y2);
		gxt.fillText("Cameron Perry", Render.gp0Width*0.75, y2);
		
		/*y += 150*Render.renderTVRatio; y2 += 60;
		cxt.font = "35px Verdana";
		cxt.fillText("~ "+_t("Cat")+" ~", Render.tvWidth*0.25, y);
		cxt.fillText("~ "+_t("Special Thanks")+" ~", Render.tvWidth*0.75, y);
		gxt.font = "25px Verdana";
		gxt.fillText("~ "+_t("Cat")+" ~", Render.gp0Width*0.25, y2);
		gxt.fillText("~ "+_t("Special Thanks")+" ~", Render.gp0Width*0.75, y2);
		y += 70*Render.renderTVRatio; y2 += 30;
		cxt.font = "40px Verdana";
		cxt.fillText("Dixie", Render.tvWidth*0.25, y);
		cxt.fillText("Emily Rogers", Render.tvWidth*0.75, y);
		gxt.font = "30px Verdana";
		gxt.fillText("Dixie", Render.gp0Width*0.25, y2);
		gxt.fillText("Emily Rogers", Render.gp0Width*0.75, y2);*/
		
		y += 140*Render.renderTVRatio; y2 += 60;
		cxt.font = "35px Verdana";
		cxt.fillText("~ "+_t("Special Thanks")+" ~", Render.tvWidth*0.5, y);
		gxt.font = "25px Verdana";
		gxt.fillText("~ "+_t("Special Thanks")+" ~", Render.gp0Width*0.5, y2);
		
		cxt.font = "40px Verdana";
		gxt.font = "30px Verdana";
		
		var str = "Emily Rogers, Michael Aschenbrenner, Megan Moody";
		y += 70*Render.renderTVRatio; y2 += 30;
		cxt.fillText(str, Render.tvWidth*0.5, y);
		gxt.fillText(str, Render.gp0Width*0.5, y2);
		str = "V\u00E9ronique Marchand, Emanuele Vivola, Deian Isac";
		y += 65*Render.renderTVRatio; y2 += 30;
		cxt.fillText(str, Render.tvWidth*0.5, y);
		gxt.fillText(str, Render.gp0Width*0.5, y2);
		
		
		var str = _t("pressbtoreturn_mainmenu");
		cxt.font = "30px Verdana";
		cxt.fillText(str, Render.tvWidth/2, Render.tvHeight-72*Render.renderTVRatio);
		//cxt.fillText("press", Render.tvWidth/2-265*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
		//cxt.fillText("to return to Main Menu", Render.tvWidth/2+120*Render.renderTVRatio, Render.tvHeight-72*Render.renderTVRatio);
		//cxt.drawImage(fontImages["b"], Render.tvWidth/2-190*Render.renderTVRatio, Render.tvHeight-62*Render.renderTVRatio, 48*Render.renderTVRatio, 48*Render.renderTVRatio);
		
		gxt.font = "25px Verdana";
		gxt.fillText(str, Render.gp0Width/2, Render.gp0Height-40);
		//gxt.fillText("press", Render.gp0Width/2-145, Render.gp0Height-50);
		//gxt.fillText("to return to Main Menu", Render.gp0Width/2+75, Render.gp0Height-50);
		//gxt.drawImage(fontImages["b"], Render.gp0Width/2-100, Render.gp0Height-45, 28, 28);
	};
};
var Credits = new Credits();