function GameOver()
{
	this.data = {};
	this.score = 0; this.money = 0; this.moneyCountdown = 1;
	this.loan = 0; this.loanCoutndown = 1;
	this.gameoverScreenshot = null;
	
	this.inititals = "";
	this.triggerOnIndex = 0;
	this.triggerOnIndexMax = 4;
	
	this.area = "gameover_newscore";
	this.scoreCountdownHandle = null;
	
	this.mv = null;
	this.mvCanConnect = true;
	this.mvInitCount = 0;
	this.mvChecked = false;
	this.mvTryToPost = false;
	
	this.act = null;
	this.actCanMiiverse = false;
	this.actCanInternet = false;
	
	//Show the Game Over screen
	this.init = function(data)
	{
		nwf.system.Memory.requestGC();
		this.data = data;
		this.score = data.score;
		this.money = data.money;
		this.moneyCountdown = Math.min(Math.ceil(this.money / 50), 10000000);
		this.loan = data.loan;
		this.loanCountdown = Math.ceil(this.loan / 100);
		
		//Leaderboard.onlineConnect(0);
		
		this.act = Render.act;//nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
		this.actCanMiiverse = Render.actCanMiiverse;//this.act.miiverseRestrictionLevel == nwf.act.NintendoAccount.RESTRICTION_NONE;
		this.actCanInternet = Render.actCanInternet;//this.act.networkCommunicationAllowed;
		
		this.mvTryToPost = false;
		if (!this.mv)
		{
			//this.mvCanConnect = false;
			this.mv = nwf.mv.Miiverse.getInstance();
			var MiiverseEvent = nwf.events.MiiverseEvent;
			
			this.mv.addEventListener(
				MiiverseEvent.INITIALIZATION_SUCCESS, 
				function(){
					GameOver.mvCanConnect = true;
					
					if (GameOver.mvTryToPost)
					{
						GameOver.postToMiiverse();
					}
				}, 
				this
			);
			this.mv.addEventListener(
				MiiverseEvent.INITIALIZATION_FAILED, 
				function(){
					GameOver.mvInitCount++;
					if (GameOver.mvInitCount < 1 && 0)
						setTimeout(function(){ GameOver.mv.initialize(); }, 250);
					else
						GameOver.mvCanConnect = true;
				}, 
				this
			);
			this.mv.addEventListener(
				MiiverseEvent.UPLOAD_POST_FAILED, 
				function(){ GameOver.postToMiiverseFail(); }, 
				this
			);
		}
		
		var display = nwf.display.DisplayManager.getInstance().getTVDisplay();
		display.captureScreen( function( img ){
			GameOver.gameoverScreenshot = img;
		}, { width:Render.tvWidth, height:Render.tvHeight });
		
		this.area = "addupscore";
		this.isPostingToMiiverse = false;
		clearInterval(this.scoreCountdownHandle);
		this.scoreCountdownHandle = setInterval(function()
		{
			GameOver.scoreCountdown();
		}, 25);
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		if (Render.sounds["mainmenu"].readyState > 0)
			Render.sounds["mainmenu"].currentTime = 0;
		Render.sounds["mainmenu"].play();
		
		//Move selected button up|down or press a to activate button
		this.triggerOnIndex = 0;
		InputBank.add({
			id: "button",
			type: ["up", "down", "a", "start"],
			controller: "any",
			action: function(clickID, vaultEntry, type)
			{
				switch(type)
				{
				case "up":
					if (GameOver.area == "gameover")
					{
						GameOver.triggerOnIndex--;
						if (GameOver.triggerOnIndex < 0) GameOver.triggerOnIndex = 0;
					}
				break;
				
				case "down":
					if (GameOver.area == "gameover")
					{
						GameOver.triggerOnIndex++;
						if (GameOver.triggerOnIndex >= GameOver.triggerOnIndexMax) GameOver.triggerOnIndex = GameOver.triggerOnIndexMax-1;
						if (!GameOver.actCanMiiverse && GameOver.triggerOnIndex == GameOver.triggerOnIndexMax-1)
							GameOver.triggerOnIndex--;
					}
				break;
				
				case "a":
					if (GameOver.area == "addupscore")
					{
						clearInterval(GameOver.scoreCountdownHandle);
						GameOver.score += GameOver.money*3;
						GameOver.money = 0;
						GameOver.score -= GameOver.loan*2;
						GameOver.loan = 0;
						GameOver.area = "end_onlinesave";
					} else if (GameOver.area == "end_offlinesave22222") {
						GameOver.area = "end";
					} else if (GameOver.area == "gameover") {
						if (GameOver.triggerOnIndex == 0) Game.mapClass.init();
						else if (GameOver.triggerOnIndex == 1) {
							Leaderboard.init({
								type: "gameover",
								map: GameOver.data.map,
								area: "local",
								mode: GameOver.data.mode.toLowerCase()
							});
						}
						else if (GameOver.triggerOnIndex == 2) MainMenu.init();
						else if (GameOver.triggerOnIndex == 3) {
							GameOver.postToMiiverse();
						}
					}
				break;
				
				case "start":
					if (GameOver.area == "gameover" || GameOver.area == "gameover_newscore")
						MainMenu.init();
				break;
				}
			}
		});
		
		Render.renderControl = function(){ GameOver.render(); };
	};
	
	//Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		gxt.setTransform(1, 0, 0, 1, 0, 0);
		
		//Black Background
		if (this.area != "gameover" && 0)
		{
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(Render.images["space1"], 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(Render.images["space1"], 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.7; gxt.globalAlpha = 0.7;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		} else {
			cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
			cxt.drawImage(GameOver.gameoverScreenshot, 0, 0, Render.tvWidth, Render.tvHeight);
			gxt.drawImage(GameOver.gameoverScreenshot, 0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 0.6; gxt.globalAlpha = 0.6;
			cxt.fillRect(0, 0, Render.tvWidth, Render.tvHeight);
			gxt.fillRect(0, 0, Render.gp0Width, Render.gp0Height);
			cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		}
		
		//Game Over Screen
		cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
		cxt.textAlign = "center"; gxt.textAlign = "center";
		cxt.font = "60px Verdana"; gxt.font = "40px Verdana";
		var str = _t(Game.map+"_title")+": "+_t("GAMEOVER");
		var font2 = 60;
		while(font2 > 45 && cxt.measureText(str).width+6 > Render.tvWidth-100)
		{
			font2--;
			cxt.font = font2+"px Verdana";
		}
		cxt.fillText(str, Render.tvWidth/2, 15);
		var font2 = 40;
		while(font2 > 25 && gxt.measureText(str).width+6 > Render.gp0Width-50)
		{
			font2--;
			gxt.font = font2+"px Verdana";
		}
		gxt.fillText(str, Render.gp0Width/2, 5);
		
		
		//Area
		switch(this.area)
		{
		default:
		case "addupscore":
			var x,x2,y,y2;
			cxt.font = "40px Verdana"; gxt.font = "25px Verdana";
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			x = Render.trueWidth*2/4*Render.renderTVRatio; x2 = Render.gp0Width*2/4;
			y = 225*Render.renderTVRatio; y2 = 125;
			
			cxt.textAlign = "right"; gxt.textAlign = "right";
			cxt.fillText(_t("Final Score")+":", Render.trueWidth*2/4*Render.renderTVRatio-50, y);
			gxt.fillText(_t("Final Score")+":", Render.gp0Width*2/4-25, y2);
			cxt.textAlign = "left"; gxt.textAlign = "left";
			cxt.fillText(Leaderboard.numberFormat(this.score), x, y);
			gxt.fillText(Leaderboard.numberFormat(this.score), x2, y2);
			
			y+=75*Render.renderTVRatio; y2+=35;
			cxt.fillText("+", x-40*Render.renderTVRatio, y);
			gxt.fillText("+", x2-20, y2);
			cxt.fillText("3 x ", x, y);
			gxt.fillText("3 x ", x2, y2);
			x += cxt.measureText("3 x ").width;
			x2 += gxt.measureText("3 x ").width;
			cxt.fillText(this.money, x, y);
			gxt.fillText(this.money, x2, y2);
			
			if (this.data.loan > 0)
			{
				x = Render.trueWidth*2/4*Render.renderTVRatio; x2 = Render.gp0Width*2/4;
				y+=75*Render.renderTVRatio; y2+=35;
				cxt.fillText("-", x-40*Render.renderTVRatio, y);
				gxt.fillText("-", x2-20, y2);
				cxt.fillText("2 x ", x, y);
				gxt.fillText("2 x ", x2, y2);
				x += cxt.measureText("2 x ").width;
				x2 += gxt.measureText("2 x ").width;
				cxt.fillText(this.loan, x, y);
				gxt.fillText(this.loan, x2, y2);
			}
		break;
		
		case "end_onlinesave":
			//Save Top Score
			if (SplashScreen.setupData != undefined)
			{
				var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
				var actName = myAct.accountID ? myAct.accountID : "Player";
				var SaveType = actName+"/"+GameOver.data.map+"/"+GameOver.data.mode;
				if (typeof SplashScreen.setupData.topScores == "undefined")
					SplashScreen.setupData.topScores = {"": ""};
				if ((typeof SplashScreen.setupData.topScores[SaveType] == "undefined" || parseInt(SplashScreen.setupData.topScores[SaveType].score) <= GameOver.score)
					&& GameOver.data.mode.toLowerCase() != "easy")
				{
					SplashScreen.setupData.topScores[SaveType] = {score: GameOver.score, level: GameOver.data.level};
					this.area = "end_onlinesave2";
					
					//Send Online Score to Server
					function _sendOnlineScore()
					{
						if (!GameOver.actCanInternet)
						{
							GameOver.area = "end_offlinesave";
							
							return false;
						}
						
						function _saveScore()
						{
							var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
							
							var newScore = Math.ceil(GameOver.score/100);//*1000;
							//newScore += GameOver.data.level < 1000 ? GameOver.data.level : 999;
							if (Leaderboard.onlineScores[GameOver.data.map] && Leaderboard.onlineScores[GameOver.data.map][GameOver.data.mode.toLowerCase()] &&
								Leaderboard.onlineScores[GameOver.data.map][GameOver.data.mode.toLowerCase()]["all"])
								Leaderboard.onlineScores[GameOver.data.map][GameOver.data.mode.toLowerCase()]["all"].lastGrab = 0;
							Leaderboard.uploadScore(newScore, __Maps[GameOver.data.map].online[GameOver.data.mode],
								[myAct.accountID ? myAct.accountID : "Player"],
								function()
								{
									//GameOver.area = "end";
									
									Leaderboard.onlineScores[""][GameOver.data.mode.toLowerCase()]["all"].lastGrab = 0;
									var playerName = myAct.accountID ? myAct.accountID : "Player";
									Leaderboard.uploadTop5Avg(playerName, GameOver.data.mode, function()
									{
										//GameOver.area = "end";
										
										Leaderboard.uploadOfflineScores(function()
										{
											GameOver.area = "end";
										}, function()
										{
											GameOver.area = "end";
										});
									});
								}, _nosaveScore);
						};
						function _nosaveScore()
						{
							GameOver.area = "end_offlinesave";
						};
						
						if (!Leaderboard.isOnline)
						{
							Leaderboard.onlineConnect(0, _saveScore, _nosaveScore);
						} else {
							_saveScore();
						}
					};
					
					FileIO.saveFile("setup.txt", SplashScreen.setupData, function()
					{
						//GameOver.area = "end_offlinesave";
						_sendOnlineScore();
					}, function()
					{
						//GameOver.area = "end_offlinesave";
						_sendOnlineScore();
					});
				} else {
					//GameOver.area = "end";
					
					Leaderboard.uploadOfflineScores(function()
					{
						GameOver.area = "end";
					}, function()
					{
						GameOver.area = "end";
					});
				}
			} else {
				GameOver.area = "end";
			}
			
			/*if (Leaderboard.scores[this.data.map] != undefined && Leaderboard.scores[this.data.map][this.data.mode.toLowerCase()+"_online"] != undefined)
			{
				if (this.score > parseInt(Leaderboard.scores[this.data.map][this.data.mode.toLowerCase()+"_online"]))
				{
					this.area = "end_onlinesave2";
					Leaderboard.scores[this.data.map][this.data.mode.toLowerCase()+"_online"] = this.score;
					
					FileIO.saveFile("leaderboard.txt", Leaderboard.scores, function()
					{
						
					}, function()
					{
						GameOver.area = "end";
					});
				} else {
					this.area = "end";
				}
			} else {
				this.area = "end";
			}*/
		break;
		
		case "end_onlinesave2":
			//Stats
			var x,x2,y,y2;
			cxt.font = "35px Verdana"; gxt.font = "25px Verdana";
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			var stats = [];
			if (this.data.mode != "Endless")
				stats.push({title: ""+_t("Max Level")+":", value: this.data.level});
			else
				stats.push({title: ""+_t("Enemies Crushed")+":", value: this.data.enemies});
			stats.push({title: ""+_t("Final Score")+":", value: Leaderboard.numberFormat(this.score)});
			stats.push({title: ""+_t("Money Left")+":", value: "$"+Leaderboard.numberFormat(this.data.money)});
			if (this.data.loan > 0)
				stats.push({title: ""+_t("Loan Amount Owed")+":", value: "$"+Leaderboard.numberFormat(this.data.loan)});
			stats.push({title: ""+_t("Mode")+":", value: _t(this.data.mode == "Endless" ? "Endurance" : this.data.mode)});
			x = Render.trueWidth*2/4*Render.renderTVRatio; x2 = Render.gp0Width*2/4;
			y = 175*Render.renderTVRatio; y2 = 75;
			for(var key in stats)
			{
				var stat = stats[key];

				cxt.textAlign = "right"; gxt.textAlign = "right";
				cxt.fillText(stat.title, (Render.trueWidth*2/4-50)*Render.renderTVRatio, y);
				gxt.fillText(stat.title, (Render.gp0Width*2/4-25), y2);
				
				cxt.textAlign = "left"; gxt.textAlign = "left";
				cxt.fillText(stat.value, x, y);
				gxt.fillText(stat.value, x2, y2);
				
				y += 70*Render.renderTVRatio; y2 += 32;
			}
			
			//Show score
			var x,x2,score = Leaderboard.numberFormat(this.score);
			cxt.font = "50px Verdana"; gxt.font = "30px Verdana";
			cxt.textAlign = "center"; gxt.textAlign = "center";
			
			x = Render.trueWidth/2*Render.renderTVRatio; x2 = Render.gp0Width/2;
			y += 50; y2 += 40;
			//y = 575*Render.renderTVRatio; y2 = 90;
			var str = _t("gameover_1").replace(/\[amt\]/i, score);
			var lines = Render.splitText(cxt, str, Render.trueWidth*Render.renderTVRatio-100);
			for(var key in lines)
			{
				cxt.fillText(lines[key], x, y);
				y += 60;
			}
			var lines = Render.splitText(gxt, str, Render.gp0Width-50);
			for(var key in lines)
			{
				gxt.fillText(lines[key], x2, y2);
				y2 += 40;
			}
			
			y += 75; y2 += 40;
			var str = _t("gameover_2");
			var lines = Render.splitText(cxt, str, Render.trueWidth*Render.renderTVRatio-100);
			for(var key in lines)
			{
				cxt.fillText(lines[key], x, y);
				y += 60;
			}
			var lines = Render.splitText(gxt, str, Render.gp0Width-50);
			for(var key in lines)
			{
				gxt.fillText(lines[key], x2, y2);
				y2 += 40;
			}
		break;

		case "end_offlinesave":
			if (SplashScreen.setupData != undefined)
			{
				var myAct = nwf.act.NintendoAccountManager.getInstance().getActiveAccount();
				var actName = myAct.accountID ? myAct.accountID : "Player";
				var SaveType = actName+"/"+this.data.map+"/"+this.data.mode;
				var setupDataChanged = false;
				
				if (typeof SplashScreen.setupData.topScores == "undefined")
					SplashScreen.setupData.topScores = {"": ""};
				if (typeof SplashScreen.setupData.topScores[SaveType] == "undefined" || parseInt(SplashScreen.setupData.topScores[SaveType].score) <= GameOver.score)
				{
					SplashScreen.setupData.topScores[SaveType] = {score: GameOver.score, level: GameOver.data.level};
					setupDataChanged = true;
					
					if (typeof SplashScreen.setupData.offlineScores == "undefined")
						SplashScreen.setupData.offlineScores = {"": ""};
					if (typeof SplashScreen.setupData.offlineScores[SaveType] == "undefined" || parseInt(SplashScreen.setupData.offlineScores[SaveType].score) < this.score)
					{
						SplashScreen.setupData.offlineScores[SaveType] = {score: this.score, level: this.data.level};
						setupDataChanged = true;
					}
				}
				
				if (setupDataChanged)
				{
					this.area = "end_onlinesave2";
					
					FileIO.saveFile("setup.txt", SplashScreen.setupData, function()
					{
						GameOver.area = "end";
					}, function()
					{
						GameOver.area = "end";
					});
				} else {
					this.area = "end";
				}
			} else {
				this.area = "end";
			}
		break;
		
		case "end_offlinesave2":
			//Stats
			var x,x2,y,y2;
			cxt.font = "35px Verdana"; gxt.font = "25px Verdana";
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			var stats = [];
			if (this.data.mode != "Endless")
				stats.push({title: ""+_t("Max Level")+":", value: this.data.level});
			else
				stats.push({title: ""+_t("Enemies Crushed")+":", value: this.data.enemies});
			stats.push({title: ""+_t("Final Score")+":", value: Leaderboard.numberFormat(this.score)});
			stats.push({title: ""+_t("Money Left")+":", value: "$"+Leaderboard.numberFormat(this.data.money)});
			if (this.data.loan > 0)
				stats.push({title: ""+_t("Loan Amount Owed")+":", value: "$"+Leaderboard.numberFormat(this.data.loan)});
			stats.push({title: ""+_t("Mode")+":", value: _t(this.data.mode == "Endless" ? "Endurance" : this.data.mode)});
			x = Render.trueWidth*2/4*Render.renderTVRatio; x2 = Render.gp0Width*2/4;
			y = 175*Render.renderTVRatio; y2 = 75;
			for(var key in stats)
			{
				var stat = stats[key];

				cxt.textAlign = "right"; gxt.textAlign = "right";
				cxt.fillText(stat.title, (Render.trueWidth*2/4-50)*Render.renderTVRatio, y);
				gxt.fillText(stat.title, (Render.gp0Width*2/4-25), y2);
				
				cxt.textAlign = "left"; gxt.textAlign = "left";
				cxt.fillText(stat.value, x, y);
				gxt.fillText(stat.value, x2, y2);
				
				y += 70*Render.renderTVRatio; y2 += 32;
			}
			
			//Show score
			var x,x2,score = Leaderboard.numberFormat(this.score);
			cxt.font = "50px Verdana"; gxt.font = "30px Verdana";
			cxt.textAlign = "center"; gxt.textAlign = "center";
			
			x = Render.trueWidth/2*Render.renderTVRatio; x2 = Render.gp0Width/2;
			y += 50; y2 += 40;
			//y = 575*Render.renderTVRatio; y2 = 90;
			var str = _t("gameover_1").replace(/\[amt\]/i, score);
			var lines = Render.splitText(cxt, str, Render.trueWidth*Render.renderTVRatio-100);
			for(var key in lines)
			{
				cxt.fillText(lines[key], x, y);
				y += 60;
			}
			var lines = Render.splitText(gxt, str, Render.gp0Width-50);
			for(var key in lines)
			{
				gxt.fillText(lines[key], x2, y2);
				y2 += 40;
			}
			
			y += 75; y2 += 40;
			var str = _t("gameover_2");
			var lines = Render.splitText(cxt, str, Render.trueWidth*Render.renderTVRatio-100);
			for(var key in lines)
			{
				cxt.fillText(lines[key], x, y);
				y += 60;
			}
			var lines = Render.splitText(gxt, str, Render.gp0Width-50);
			for(var key in lines)
			{
				gxt.fillText(lines[key], x2, y2);
				y2 += 40;
			}
		break;
		
		case "end":
			if (Leaderboard.scores[this.data.map] != undefined && Leaderboard.scores[this.data.map][this.data.mode.toLowerCase()] != undefined
					&& Leaderboard.scores[this.data.map][this.data.mode.toLowerCase()] != null)
			{
				var local = Leaderboard.scores[this.data.map][this.data.mode.toLowerCase()];
				if (local[local.length-1].score < this.score)
				{
					this.inititals = "";
					this.area = "gameover_newscore";
					
					//Need to replace with general class?
					var keyboard = nwf.input.SoftwareKeyboard;
					var ops = {
						'display': nwf.input.SoftwareKeyboard.DISPLAY_GAMEPAD_0,
					    'mode': nwf.input.SoftwareKeyboard.MODE_FULL,
					    'fullscreen': false
					};
					try
					{
						keyboard.invoke( onKeyPress, ops );
					} catch(err) {}
					function onKeyPress(options)
					{
						var text = options.text;
						var userSelected = options.user_select;
						
						switch(userSelected)
						{
						case keyboard.USER_OK:
							if (GameOver.inititals != "")
							{
								var local = Leaderboard.scores[GameOver.data.map][GameOver.data.mode.toLowerCase()].slice();
								local.push({name: GameOver.inititals, score: GameOver.score});
								local.sort(function(a, b)
								{
									return b.score - a.score;
								});
								local.pop();
								Leaderboard.scores[GameOver.data.map][GameOver.data.mode.toLowerCase()] = local;
								
								FileIO.saveFile("leaderboard.txt", Leaderboard.scores, function()
								{
									GameOver.area = "gameover";
								}, function()
								{
									GameOver.area = "gameover";
								});
							} else {
								GameOver.area = "gameover";
							}
						break;
						
						case keyboard.USER_CANCEL:
							GameOver.area = "gameover";
						break;
						
						case keyboard.USER_BACKSPACE:
							GameOver.inititals = GameOver.inititals.slice(0, GameOver.inititals.length-1);
						break;
						
						case keyboard.USER_CHAR:
							if (GameOver.inititals.length < 3)
								GameOver.inititals += text;
						break;
						
						default:
							//Error?
							GameOver.area = "gameover";
						break;
						}
					};
				} else {
					this.area = "gameover";
				}
			} else {
				this.area = "gameover";
			}
		break;
		
		case "gameover_newscore":
			//Stats
			var x,x2,y,y2;
			cxt.font = "35px Verdana"; gxt.font = "25px Verdana";
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			var stats = [];
			if (this.data.mode != "Endless")
				stats.push({title: ""+_t("Max Level")+":", value: this.data.level});
			else
				stats.push({title: ""+_t("Enemies Crushed")+":", value: this.data.enemies});
			stats.push({title: ""+_t("Final Score")+":", value: Leaderboard.numberFormat(this.score)});
			stats.push({title: ""+_t("Money Left")+":", value: "$"+Leaderboard.numberFormat(this.data.money)});
			if (this.data.loan > 0)
				stats.push({title: ""+_t("Loan Amount Owed")+":", value: "$"+Leaderboard.numberFormat(this.data.loan)});
			stats.push({title: ""+_t("Mode")+":", value: _t(this.data.mode == "Endless" ? "Endurance" : this.data.mode)});
			x = Render.trueWidth*2/4*Render.renderTVRatio; x2 = Render.gp0Width*2/4;
			y = 175*Render.renderTVRatio; y2 = 75;
			for(var key in stats)
			{
				var stat = stats[key];
				
				cxt.textAlign = "right"; gxt.textAlign = "right";
				cxt.fillText(stat.title, (Render.trueWidth*2/4-50)*Render.renderTVRatio, y);
				//gxt.fillText(stat.title, (Render.gp0Width*2/4-25), y2);
				
				cxt.textAlign = "left"; gxt.textAlign = "left";
				cxt.fillText(stat.value, x, y);
				//gxt.fillText(stat.value, x2, y2);
				
				y += 70*Render.renderTVRatio; y2 += 32;
			}
			
			//Show score
			var x,x2,y,y2,score = Leaderboard.numberFormat(this.score);
			cxt.font = "50px Verdana"; gxt.font = "30px Verdana";
			cxt.textAlign = "center"; gxt.textAlign = "center";
			
			x = Render.trueWidth/2*Render.renderTVRatio; x2 = Render.gp0Width/2;
			y = 575*Render.renderTVRatio; y2 = 90;
			var str = _t("gameover_1").replace(/\[amt\]/i, score);
			var lines = Render.splitText(cxt, str, Render.trueWidth*Render.renderTVRatio-100);
			for(var key in lines)
			{
				cxt.fillText(lines[key], x, y);
				y += 60;
			}
			var lines = Render.splitText(gxt, str, Render.gp0Width-50);
			for(var key in lines)
			{
				gxt.fillText(lines[key], x2, y2);
				y2 += 40;
			}

			cxt.font = "35px Verdana"; gxt.font = "25px Verdana";
			y += 150*Render.renderTVRatio; y2 += 85;
			var str = _t("gameover_3");
			var lines = Render.splitText(cxt, str, Render.trueWidth*Render.renderTVRatio-100);
			for(var key in lines)
			{
				cxt.fillText(lines[key], x, y);
				y += 45;
			}
			var lines = Render.splitText(gxt, str, Render.gp0Width-50);
			for(var key in lines)
			{
				gxt.fillText(lines[key], x2, y2);
				y2 += 32;
			}
			
			cxt.textAlign = "left"; gxt.textAlign = "left";
			x = Render.trueWidth*0.64*Render.renderTVRatio;
			x2 = Render.gp0Width*0.655;
			cxt.fillText(this.inititals, x, y);
			gxt.fillText(this.inititals, x2, y2);
		break;
		
		case "gameover":
			//Stats
			var x,x2,y,y2;
			cxt.font = "35px Verdana"; gxt.font = "25px Verdana";
			cxt.textAlign = "left"; gxt.textAlign = "left";
			
			var stats = [];
			if (this.data.mode != "Endless")
				stats.push({title: ""+_t("Max Level")+":", value: this.data.level});
			else
				stats.push({title: ""+_t("Enemies Crushed")+":", value: this.data.enemies});
			stats.push({title: ""+_t("Final Score")+":", value: Leaderboard.numberFormat(this.score)});
			stats.push({title: ""+_t("Money Left")+":", value: "$"+Leaderboard.numberFormat(this.data.money)});
			if (this.data.loan > 0)
				stats.push({title: ""+_t("Loan Amount Owed")+":", value: "$"+Leaderboard.numberFormat(this.data.loan)});
			stats.push({title: ""+_t("Mode")+":", value: _t(this.data.mode == "Endless" ? "Endurance" : this.data.mode)});
			x = Render.trueWidth*2/4*Render.renderTVRatio; x2 = Render.gp0Width*2/4;
			y = 175*Render.renderTVRatio; y2 = 75;
			for(var key in stats)
			{
				var stat = stats[key];
				
				cxt.textAlign = "right"; gxt.textAlign = "right";
				cxt.fillText(stat.title, (Render.trueWidth*2/4-50)*Render.renderTVRatio, y);
				gxt.fillText(stat.title, (Render.gp0Width*2/4-25), y2);
				
				cxt.textAlign = "left"; gxt.textAlign = "left";
				cxt.fillText(stat.value, x, y);
				gxt.fillText(stat.value, x2, y2);
				
				y += 70*Render.renderTVRatio; y2 += 32;
			}
			
			if (this.actCanMiiverse || Render.actCanMiiverseShow)
			{
				gxt.font = "35px Verdana";
				gxt.textAlign = "center";
				gxt.fillText(_t("gameover_4"), Render.gp0Width/2, y2+22);
				gxt.textAlign = "left";
			}
			
			
			//Options
			/*cxt.lineWidth = 1; gxt.lineWidth = 1;
			cxt.font = "75px Verdana"; gxt.font = "40px Verdana";
			cxt.textAlign = "center"; gxt.textAlign = "center";
			cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
			var x = Render.tvWidth/2, y = 650, w = 600, h = 125,
				x2 = Render.gp0Width/2, y2 = 280, w2 = 350, h2 = 60,
				bcDefault = "#AAA", bcOn = "#FFF", bc,
				bgDefault = "#000", bgOn = "#333", bg;
			
			//Option: Restart
			bc = this.triggerOnIndex == 0 ? bcOn : bcDefault;
			bg = this.triggerOnIndex == 0 ? bgOn : bgDefault;
			cxt.strokeStyle = bc; gxt.strokeStyle = bc;
			cxt.fillStyle = bg; gxt.fillStyle = bg;
			cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 0 ? "2" : "1")], x-w/2, y-h/2, w, h);
			gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 0 ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
			cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
			cxt.strokeRect(x-w/2, y-h/2, w, h);
			gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
			cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			cxt.fillText("Restart", x, y);
			gxt.fillText("Restart", x2, y2);
			
			ClickBank.add({
				id: "restart",
				x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
				click: function(clickID, vaultEntry)
				{
					Game.mapClass.init();
				}
			});
			
			y += h*1.25; y2 += h2*1.25;
			
			//Option: Highscores
			bc = this.triggerOnIndex == 1 ? bcOn : bcDefault;
			bg = this.triggerOnIndex == 1 ? bgOn : bgDefault;
			cxt.strokeStyle = bc; gxt.strokeStyle = bc;
			cxt.fillStyle = bg; gxt.fillStyle = bg;
			cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 1 ? "2" : "1")], x-w/2, y-h/2, w, h);
			gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 1 ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
			cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
			cxt.strokeRect(x-w/2, y-h/2, w, h);
			gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
			cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			cxt.fillText("Highscores", x, y);
			gxt.fillText("Highscores", x2, y2);
			
			ClickBank.add({
				id: "highscores",
				x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
				click: function(clickID, vaultEntry)
				{
					Leaderboard.init({
						type: "gameover",
						map: GameOver.data.map,
						area: "local",
						mode: GameOver.data.mode.toLowerCase()
					});
				}
			});

			y += h*1.25; y2 += h2*1.25;
			
			//Option: Main Menu
			bc = this.triggerOnIndex == 2 ? bcOn : bcDefault;
			bg = this.triggerOnIndex == 2 ? bgOn : bgDefault;
			cxt.strokeStyle = bc; gxt.strokeStyle = bc;
			cxt.fillStyle = bg; gxt.fillStyle = bg;
			cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 2 ? "2" : "1")], x-w/2, y-h/2, w, h);
			gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 2 ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
			cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
			cxt.strokeRect(x-w/2, y-h/2, w, h);
			gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
			cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
			cxt.fillText("Main Menu", x, y);
			gxt.fillText("Main Menu", x2, y2);
			
			ClickBank.add({
				id: "mainmenu",
				x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
				click: function(clickID, vaultEntry)
				{
					MainMenu.init();
				}
			});
			
			y += h*1.25; y2 += h2*1.25;*/
			
			//Options
			if (!this.isPostingToMiiverse || 1)
			{
				cxt.lineWidth = 1; gxt.lineWidth = 1;
				cxt.font = "75px Verdana"; gxt.font = "40px Verdana";
				cxt.textAlign = "center"; gxt.textAlign = "center";
				cxt.textBaseline = "middle"; gxt.textBaseline = "middle";
				var x = 575, y = 750, w = 700, h = 125,
					x2 = Render.gp0Width/4, y2 = 365, w2 = 400, h2 = 60,
					bcDefault = "#AAA", bcOn = "#FFF", bc,
					bgDefault = "#000", bgOn = "#333", bg;
				
				//Option: Restart
				bc = this.triggerOnIndex == 0 ? bcOn : bcDefault;
				bg = this.triggerOnIndex == 0 ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				//cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 0 ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 0 ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				//cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				//cxt.fillText("Restart", x, y);
				gxt.fillText("Restart", x2, y2);
				
				ClickBank.add({
					id: "restart",
					x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
					click: function(clickID, vaultEntry)
					{
						Game.mapClass.init();
					}
				});
				
				x = Render.tvWidth-575; x2 += Render.gp0Width/2;
				
				//Option: Highscores
				bc = this.triggerOnIndex == 1 ? bcOn : bcDefault;
				bg = this.triggerOnIndex == 1 ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				//cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 1 ? "2" : "1")+""], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 1 ? "2" : "1")+""], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				//cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				//cxt.fillText("Highscores", x, y);
				gxt.fillText("Highscores", x2, y2);
				
				ClickBank.add({
					id: "highscores",
					x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
					click: function(clickID, vaultEntry)
					{
						Leaderboard.init({
							type: "gameover",
							map: GameOver.data.map,
							area: "local",
							mode: GameOver.data.mode.toLowerCase()
						});
					}
				});
				
				
				x = 575; x2 = Render.gp0Width/4;
				y += h*1.25; y2 += h2*1.25;
				
				//Option: Main Menu
				bc = this.triggerOnIndex == 2 ? bcOn : bcDefault;
				bg = this.triggerOnIndex == 2 ? bgOn : bgDefault;
				cxt.strokeStyle = bc; gxt.strokeStyle = bc;
				cxt.fillStyle = bg; gxt.fillStyle = bg;
				//cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 2 ? "2" : "1")], x-w/2, y-h/2, w, h);
				gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 2 ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
				cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
				//cxt.strokeRect(x-w/2, y-h/2, w, h);
				gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
				cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
				//cxt.fillText("Main Menu", x, y);
				gxt.fillText("Main Menu", x2, y2);
				
				ClickBank.add({
					id: "mainmenu",
					x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
					click: function(clickID, vaultEntry)
					{
						MainMenu.init();
					}
				});
				
				
				if (this.actCanMiiverse || Render.actCanMiiverseShow)
				{
					x = Render.tvWidth-575; x2 += Render.gp0Width/2;
					
					bc = this.triggerOnIndex == 3 ? bcOn : bcDefault;
					bg = this.triggerOnIndex == 3 ? bgOn : bgDefault;
					cxt.strokeStyle = bc; gxt.strokeStyle = bc;
					cxt.fillStyle = bg; gxt.fillStyle = bg;
					//cxt.drawImage(Render.images["button"+(this.triggerOnIndex == 3 ? "2" : "1")], x-w/2, y-h/2, w, h);
					if ((this.mv.isReady || !this.mvChecked) && this.actCanMiiverse)
						gxt.drawImage(Render.images["button"+(this.triggerOnIndex == 3 ? "2" : "1")], x2-w2/2, y2-h2/2, w2, h2);
					else
						gxt.drawImage(Render.images["button_grey"], x2-w2/2, y2-h2/2, w2, h2);
					cxt.strokeStyle = "#666"; gxt.strokeStyle = "#666";
					//cxt.strokeRect(x-w/2, y-h/2, w, h);
					gxt.strokeRect(x2-w2/2, y2-h2/2, w2, h2);
					cxt.fillStyle = "#FFF"; gxt.fillStyle = "#FFF";
					//cxt.fillText("Post To Miiverse", x, y);
					gxt.fillText(_t("Post To Miiverse"), x2, y2);
					
					ClickBank.add({
						id: "miiversepost",
						x: x2-w2/2, y: y2-h2/2, w: w2, h: h2,
						click: function(clickID, vaultEntry)
						{
							GameOver.postToMiiverse();
						}
					});
				}
			}
		break;
		}
		
		cxt.textBaseline = "top"; gxt.textBaseline = "top";
		cxt.textAlign = "left"; gxt.textAlign = "left";
	};
	
	//Post to Miiverse
	this.isPostingToMiiverse = false; //this.isPostingTimeoutHandle = null;
	this.postToMiiverse = function()
	{
		if (this.isPostingToMiiverse || !this.actCanMiiverse) return false;
		this.isPostingToMiiverse = true;
		
		//var mv = nwf.mv.Miiverse.getInstance();
		//mv.initialize();
		if (!this.mv.isReady)
		{
			this.mvChecked = true;
			this.postToMiiverseFail();
			
			//Try to connect again?
			if (this.mvCanConnect)
			{
				if (!nwf.net.Network.isConnected())
				{
					DialogConnectOnline.init(function()
					{
						GameOver.mvCanConnect = false;
						GameOver.mvTryToPost = true;
						GameOver.mv.initialize();
					});
				} else {
					nwf.system.WiiUSystem.getInstance().homeButtonEnabled = false;
					
					this.mvCanConnect = false;
					this.mvTryToPost = true;
					this.mv.initialize();
				}
			}
			
			return false;
		}
		if (!this.mvCanConnect)
		{
			this.postToMiiverseFail();
		}
		
		if (0) {
		var canvas = document.createElement("canvas"),
			cxt = context = canvas.getContext("2d");
		canvas.width = 800;
		canvas.height = 450;
		
		context.drawImage(this.gameoverScreenshot, 0, 0);
		
		cxt.fillRect(100, 100, 250, 250);
		
		var img = document.createElement("img");
		img.width = 800;
		img.height = 450;
		img.addEventListener("load", function()
		{
			console.log(img.complete);
			//img.complete = true;
			
			var mvPost = new nwf.mv.MiiverseUploadPost();
			mvPost.body = "Check out my new score on "+__Maps[GameOver.data.map].title+" in "+GameOver.data.mode+" Mode!";
			mvPost.screenshot = img;
			
			var rtr = GameOver.mv.sendPost(mvPost);
			GameOver.postToMiiverseFail();
		}, false);
		img.src = canvas.toDataURL('image/jpeg');
		}
		
		//return false;
		/*GameOver.render();
		setTimeout(function()
		{*/
		
		nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		//this.isPostingTimeoutHandle = setTimeout(function()
		//{
		//	nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		//}, 5000);
		
			var display = nwf.display.DisplayManager.getInstance().getTVDisplay();
			display.captureScreen( function( img ){
				var mvPost = new nwf.mv.MiiverseUploadPost();
				
				var str = _t("gameover_5").replace(/\[title\]/i, _t(GameOver.data.map+"_title")).replace(/\[mode\]/i, _t((GameOver.data.mode == "Endless" ? "Endurance" : GameOver.data.mode)));
				mvPost.body = str;
				mvPost.screenshot = img;
				
				var rtr = GameOver.mv.sendPost(mvPost);
				GameOver.postToMiiverseFail();
			}, { width:800, height:450 });
		//}, 25);
	};
	
	this.postToMiiverseFail = function()
	{
		this.isPostingToMiiverse = false;
		
		nwf.system.WiiUSystem.getInstance().homeButtonEnabled = true;
		//clearTimeout(this.isPostingTimeoutHandle);
	};
	
	//Timer function to add up score
	this.scoreCountdown = function()
	{
		if (this.money > 0)
		{
			var amt = this.moneyCountdown;
			if (amt > this.money) amt = this.money;
			this.score += amt*3;
			this.money-=amt;
		}
		if (this.loan > 0)
		{
			var amt = this.loanCountdown;
			if (amt > this.loan) amt = this.loan;
			this.score -= amt*2;
			this.loan-=amt;
		}
		
		if (this.money <= 0 && this.loan <= 0)
		{
			clearInterval(this.scoreCountdownHandle);
			this.area = "end_onlinesave";
		}
	};
};
var GameOver = new GameOver();