function MapAMS2()
{
	this.map = "ams2";
	this.base = [{
		x: Render.trueWidth*0.115,	x2: 0,
		y: Render.trueHeight*0.115,	y2: 0,
		r: 100/2,					r2: (100/2)*Render.gp0RenderRatio,
		life: 0,
		maxLife: 25,
		shield: 0, shieldUse: 0
	}, {
		x: Render.trueWidth*0.91,		x2: 0,
		y: Render.trueHeight*0.11,	y2: 0,
		r: 100/2,					r2: (100/2)*Render.gp0RenderRatio,
		life: 0,
		maxLife: 25,
		shield: 0, shieldUse: 0
	}, {
		x: Render.trueWidth*0.915,	x2: 0,
		y: Render.trueHeight*0.875,	y2: 0,
		r: 100/2,					r2: (100/2)*Render.gp0RenderRatio,
		life: 0,
		maxLife: 25,
		shield: 0, shieldUse: 0
	}, {
		x: Render.trueWidth*0.13,		x2: 0,
		y: Render.trueHeight*0.87,	y2: 0,
		r: 100/2,					r2: (100/2)*Render.gp0RenderRatio,
		life: 0,
		maxLife: 25,
		shield: 0, shieldUse: 0
	}];
	this.storeRules = {
		drone: {createData:{movespeed: 7}}
	};
	
	this.walls = [];
	this.walls2 = [
		[{
			x: 0,
			y: 0
		}, {
			x: Render.trueWidth,
			y: 0
		}, {
			x: Render.trueWidth,
			y: Render.trueHeight
		}, {
			x: 0,
			y: Render.trueHeight
		}, {
			x: 0,
			y: 0

		}, {
			x: Render.trueWidth*0.11,
			y: Render.trueHeight*0.11
		}, {
			x: Render.trueWidth*0.09,
			y: Render.trueHeight*0.15
		}, {
			x: Render.trueWidth*0.09,
			y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.06,
			y: Render.trueHeight*0.275
		}, {
			x: Render.trueWidth*0.06,
			y: Render.trueHeight*0.4
		}, {
			x: Render.trueWidth*0.09,
			y: Render.trueHeight*0.5
		}, {
			x: Render.trueWidth*0.071,
			y: Render.trueHeight*0.64
		}, {
			x: Render.trueWidth*0.071,
			y: Render.trueHeight*0.67
		}, {
			x: Render.trueWidth*0.125,
			y: Render.trueHeight*0.805
		}, {
			x: Render.trueWidth*0.125,
			y: Render.trueHeight*0.815

		}, {
			x: Render.trueWidth*0.11,
			y: Render.trueHeight*0.855
		}, {
			x: Render.trueWidth*0.13,
			y: Render.trueHeight*0.885
		}, {
			x: Render.trueWidth*0.25,
			y: Render.trueHeight*0.91
		}, {
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.89
		}, {
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.92
		}, {
			x: Render.trueWidth*0.75,
			y: Render.trueHeight*0.89
		}, {
			x: Render.trueWidth*0.9,
			y: Render.trueHeight*0.9

		}, {
			x: Render.trueWidth*0.92,
			y: Render.trueHeight*0.885
		}, {
			x: Render.trueWidth*0.955,
			y: Render.trueHeight*0.765
		}, {
			x: Render.trueWidth*0.9,
			y: Render.trueHeight*0.58
		}, {
			x: Render.trueWidth*0.93,
			y: Render.trueHeight*0.475
		}, {
			x: Render.trueWidth*0.945,
			y: Render.trueHeight*0.32
		}, {
			x: Render.trueWidth*0.915,
			y: Render.trueHeight*0.26

		}, {
			x: Render.trueWidth*0.905,
			y: Render.trueHeight*0.076
		}, {
			x: Render.trueWidth*0.825,
			y: Render.trueHeight*0.06
		}, {
			x: Render.trueWidth*0.65,
			y: Render.trueHeight*0.076
		}, {
			x: Render.trueWidth*0.525,
			y: Render.trueHeight*0.06
		}, {
			x: Render.trueWidth*0.36,
			y: Render.trueHeight*0.08
		}, {
			x: Render.trueWidth*0.3,
			y: Render.trueHeight*0.075
		}, {
			x: Render.trueWidth*0.2,
			y: Render.trueHeight*0.065
		}, {
			x: Render.trueWidth*0.15,
			y: Render.trueHeight*0.075
			
		}, {
			x: Render.trueWidth*0.11,
			y: Render.trueHeight*0.11
		}]
	];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.15
	}, {
		x: Render.trueWidth*0.675, y: Render.trueHeight*0.25
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.675, y: Render.trueHeight*0.7
	}, {
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.8
	}, {
		x: Render.trueWidth*0.325, y: Render.trueHeight*0.7
	}, {
		x: Render.trueWidth*0.2, y: Render.trueHeight*0.5
	}, {
		x: Render.trueWidth*0.325, y: Render.trueHeight*0.25
	}];
	
	this.dronePathPointsOnReturn = [];
	this.enemyPaths = [{
		speed: 7,
		base: 0,
		path: [{
			x: Render.trueWidth*0.475,
			y: Render.trueHeight*0.475
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 7,
		base: 1,
		path: [{
			x: Render.trueWidth*0.475,
			y: Render.trueHeight*0.475
		}, {
			x: this.base[1].x,
			y: this.base[1].y
		}]
	}, {
		speed: 7,
		base: 2,
		path: [{
			x: Render.trueWidth*0.475,
			y: Render.trueHeight*0.475
		}, {
			x: this.base[2].x,
			y: this.base[2].y
		}]
	}, {
		speed: 7,
		base: 3,
		path: [{
			x: Render.trueWidth*0.475,
			y: Render.trueHeight*0.475
		}, {
			x: this.base[3].x,
			y: this.base[3].y
		}]
	}];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		this.renderBackgroundTVCover = true;
		this.renderBackgroundGP0Cover = true;
		
		//Base
		for(var key in this.base)
		{
			this.base[key].life = this.base[key].maxLife;
			this.base[key].shield = 0;
			this.base[key].shieldUse = 0;
		}
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 800});
		
		Render.gp0RenderRatio = Render.gp0RenderRatioMin;
		GameGP0Display.mapOffset.x = 118;
		GameGP0Display.mapOffset.y = 0;
		Game.mapOffsetX = 108;
		Game.mapOffsetY = 0;
		
		//Spots
		var spots = [{
			x: Render.trueWidth*0.19,
			y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.3,
			y: Render.trueHeight*0.31
		}, {
			
			x: Render.trueWidth*0.825,
			y: Render.trueHeight*0.2
		}, {
			x: Render.trueWidth*0.73,
			y: Render.trueHeight*0.31
		}, {
			
			x: Render.trueWidth*0.825,
			y: Render.trueHeight*0.75
		}, {
			x: Render.trueWidth*0.73,
			y: Render.trueHeight*0.685
		}, {

			x: Render.trueWidth*0.21,
			y: Render.trueHeight*0.78
		}, {
			x: Render.trueWidth*0.31,
			y: Render.trueHeight*0.69
		}];
		var spot;
		for(var key in spots)
		{
			spot = spots[key];
			gp0Cord = Game.calculateGPCords(spot.x, spot.y);
			
			Game.spotsAdd({
				x: spot.x, y: spot.y, r: 20,
				x2: gp0Cord.x2, y2: gp0Cord.y2, r2: 20*Render.gp0RenderRatio
			});
		}
		
		Render.renderControl = function(){ MapAMS2.render(); };
		
		Game.startGame();
		
		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//var ID = Game.botsAdd("sentry", Render.trueWidth/2, Render.trueHeight/2, Render.gp0Width/2, Render.gp0Height/2);
	};
	
	//Map Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			this.renderBackgroundGP0Cover = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		/*var base, r, rx, ry, r2, rx2, ry2, points, point, degree, radian, gp0Cord;
		for(var key in this.base)
		{
			base = this.base[key];
			if (base.life <= 0) continue;
			gp0Cord = Game.calculateGPCords(base.r, 0, true);
			base.r2 = gp0Cord.x2;
			gp0Cord = Game.calculateGPCords(base.x, base.y);
			
			r = base.r; rx = base.x - r; ry = base.y - r;
			gp0Cord = Game.calculateGPCords(rx, ry);
			r2 = base.r2; rx2 = gp0Cord.x2; ry2 = gp0Cord.y2;
			if (base.canvas == "undefiend" || base.canvasShieldInUse != (base.shield ? true : false) || base.canvasLife != base.life || base.canvasR2 != base.r2)
			{
				points = Game.getCircleClipPoints(base.x, base.y, r, 1);
				
				var newCanvas = document.createElement("canvas"),
					newCtx = newCanvas.getContext("2d"),
					newCanvas2 = document.createElement("canvas"),
					newCtx2 = newCanvas2.getContext("2d");
				newCanvas.width = r*2;
				newCanvas.height = r*2;
				newCanvas2.width = r2*2;
				newCanvas2.height = r2*2;
			    
				newCtx.fillStyle = "rgb(0, 0, 0)";
				newCtx.beginPath();
				newCtx2.fillStyle = "rgb(0, 0, 0)";
				newCtx2.beginPath();
				for(var degree in points)
				{
					point = points[degree];
					gp0Cord = Game.calculateGPCords(point.x, point.y);
					
					if (degree == 0)
					{
						newCtx.moveTo(point.x-rx, point.y-ry);
						newCtx2.moveTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
					} else {
						newCtx.lineTo(point.x-rx, point.y-ry);
						newCtx2.lineTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
					}
				}
				newCtx.fill();
				newCtx.closePath();
				newCtx2.fill();
				newCtx2.closePath();
				
			    newCtx.globalCompositeOperation = "source-in";
			    newCtx2.globalCompositeOperation = "source-in";
				
				if (base.shield > 0)
				{
					newCtx.drawImage(Render.images["base_blue"], 0, 0, r*2, r*2);
					newCtx2.drawImage(Render.images["base_blue"], 0, 0, r2*2, r2*2);
				} else {
					var p = (base.life / base.maxLife).toFixed(2);
					
					newCtx.drawImage(Render.images["base"], 0, 0, r*2, r*2);
					newCtx2.drawImage(Render.images["base"], 0, 0, r2*2, r2*2);
					if (p < 1)
					{
						var newCanvas3 = document.createElement("canvas"),
							newCtx3 = newCanvas3.getContext("2d"),
							newCanvas4 = document.createElement("canvas"),
							newCtx4 = newCanvas4.getContext("2d");
						newCanvas3.width = r*2;
						newCanvas3.height = r*2;
						newCanvas4.width = r2*2;
						newCanvas4.height = r2*2;
					    
						newCtx3.fillStyle = "rgb(0, 0, 0)";
						newCtx3.beginPath();
						newCtx4.fillStyle = "rgb(0, 0, 0)";
						newCtx4.beginPath();
						for(var degree in points)
						{
							point = points[degree];
							gp0Cord = Game.calculateGPCords(point.x, point.y);
							
							if (degree == 0)
							{
								newCtx3.moveTo(point.x-rx, point.y-ry);
								newCtx4.moveTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
							} else {
								newCtx3.lineTo(point.x-rx, point.y-ry);
								newCtx4.lineTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
							}
						}
						newCtx3.fill();
						newCtx3.closePath();
						newCtx4.fill();
						newCtx4.closePath();
						
					    newCtx3.globalCompositeOperation = "source-in";
					    newCtx4.globalCompositeOperation = "source-in";
						
						newCtx3.drawImage(Render.images["base_red"], 0, 0, r*2, r*2);
						newCtx4.drawImage(Render.images["base_red"], 0, 0, r2*2, r2*2);
						
						
					    newCtx.globalCompositeOperation = "source-over";
					    newCtx2.globalCompositeOperation = "source-over";
						
						newCtx.globalAlpha = 1-p; newCtx2.globalAlpha = 1-p;
						newCtx.drawImage(newCanvas3, 0, 0);
						newCtx2.drawImage(newCanvas4, 0, 0);
						newCtx.globalAlpha = 1; newCtx2.globalAlpha = 1;
					}
				}
				
				cxt.drawImage(newCanvas, rx, ry);
				gxt.drawImage(newCanvas2, rx2, ry2);
				
				base.canvas = newCanvas;
				base.canvas2 = newCanvas2;
				base.canvasShieldInUse = base.shield ? true : false;
				base.canvasLife = base.life;
				base.canvasR2 = base.r2;
			} else {
				cxt.drawImage(base.canvas, rx, ry);
				gxt.drawImage(base.canvas2, rx2, ry2);
			}
		}*/
		
		//Show drone recorded path
		/*cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();
		
		
		cxt.strokeStyle = "yellow"; gxt.strokeStyle = "yellow";
		
		var dronePaths;
		for(var key in this.dronePathPointsOnReturn)
		{
			dronePaths = this.dronePathPointsOnReturn[key];
			
			cxt.beginPath(); gxt.beginPath();
			for(var i=0; i<dronePaths.length; i++)
			{
				dronePath = dronePaths[i];
				gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
				
				if (i == 0)
				{
					cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
				}
				
				cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
				cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
				gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
				cxt.fillStyle = "yellow"; gxt.fillStyle = "yellow";
			}
			cxt.stroke(); gxt.stroke();
		}*/
		
		/*
		//Show Enemy Paths
		cxt.strokeStyle = "pink"; gxt.strokeStyle = "pink";
		cxt.fillStyle = "maroon"; gxt.fillStyle = "maroon";
		var points, point, point2, d;
		for(var key in this.enemyPaths)
		{
			points = this.enemyPaths[key];
			
			d = 0;
			cxt.beginPath(); gxt.beginPath();
			for(var i=0,n=points.path.length; i<n; i++)
			{
				point = points.path[i];
				gp0Cord = Game.calculateGPCords(point.x, point.y);
				
				if (i == 0)
				{
					cxt.moveTo(point.x, point.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(point.x, point.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
					point2 = points.path[i-1];
					d += Math.sqrt((point.x - point2.x)*(point.x - point2.x) + (point.y - point2.y)*(point.y - point2.y));
				}
				
				cxt.fillRect(point.x-10, point.y-10, 20, 20);
				gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			}
			cxt.stroke(); gxt.stroke();
			if (points.distance == undefined)
			{
				console.log(key, d);
				points.distance = d;
			}
		}
		*/
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
	};
	
	//Hanldes the render of the Background
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.renderBackground = function()
	{
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			
			var x=-100,y=-100,x2,y2,
				_w = Render.trueWidth+200, _h = Render.trueHeight+200,
				_w2 = _w*Render.gp0RenderRatio, _h2 = _h*Render.gp0RenderRatio;
			cxt.drawImage(Render.images["ams2_background2"], x*Render.renderTVRatio, y*Render.renderTVRatio, _w*Render.renderTVRatio, _h*Render.renderTVRatio);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			//this.renderBackgroundGP0 = false;
			
			var x=-100,y=-100,x2,y2,
				_w = Render.trueWidth+200, _h = Render.trueHeight+200,
				_w2 = _w*Render.gp0RenderRatio, _h2 = _h*Render.gp0RenderRatio;
			var gp0Cord = Game.calculateGPCords(x, y);
			gxt.drawImage(Render.images["ams2_background2"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
		}
	};
	
	//Render the background cover
	this.renderBackgroundTVCover = true; this.renderBackgroundGP0Cover = true;
	this.renderBackgroundCover = function()
	{
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTVCover)
		{
			var cxt = Render.returnTVSliceContext(8);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["ams2_background"], x, y, _w, _h);
			this.renderBackgroundTVCover = false;
		}
		if (this.renderBackgroundGP0Cover)
		{
			var gxt = Render.returnGP0SliceContext(8);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["ams2_background"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0Cover = false;
		}
		
		//Render Walls
		/*
		cxt.globalAlpha = 0.4; gxt.globalAlpha = 0.4;
		cxt.strokeStyle = "#DDD"; gxt.strokeStyle = "#DDD";
		cxt.fillStyle = "green"; gxt.fillStyle = "green";
		var walls, wall, gp0Cord;
		var colors = ["red", "green", "blue", "yellow", "purple", "pink", "white"];
		for(var key in this.walls2)
		{
			walls = this.walls2[key];
			cxt.fillStyle = colors[key];
			gxt.fillStyle = colors[key];
			
			cxt.beginPath(); gxt.beginPath();
			for(var i=0,n=walls.length; i<n; i++)
			{
				wall = walls[i];
				gp0Cord = Game.calculateGPCords(wall.x, wall.y);
				
				if (i == 0)
				{
					cxt.moveTo(wall.x, wall.y);
					gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(wall.x, wall.y);
					gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
				}
				cxt.fillRect(wall.x-25, wall.y-25, 50, 50);
			}
			cxt.fill(); gxt.fill();
			cxt.stroke(); gxt.stroke();
		}
		cxt.globalAlpha = 1; gxt.globalAlpha = 1;
		*/
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = pathData.path[1].x;
		data.destination.y = pathData.path[1].y;
		
		//Speed them up?
		var baseAlive = 0;
		for(var key in this.base)
			if (this.base[key].life > 0)
				baseAlive++;
		if (baseAlive == 2) data.speed *= 1.10;
		else if (baseAlive == 1) data.speed *= 1.25;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }
		}
		
		obj.x += xSide; obj.y += ySide;
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0
	this.moveDrone = function(ID)
	{
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*(Game.fastEnabled ? Game.fastRate : 1);
		var pathType = (bot.pointAccess == undefined || bot.pointAccess == "direct" ? "direct" : "onreturn");
		
		//Special check to make sure we did not enter infiniti loop
		this.moveDroneCount++;
		if (this.moveDroneCount >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		if (pathType == "direct")
		{
			var newpoint = bot.point + bot.direction;
			if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
			else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
			var pointMap = this.dronePathPoints[newpoint];
			var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
			if (d < speed*2)
			{
				bot.point = newpoint;
				this.moveDrone(ID);
				return true;
			}
			
			//Does this new point not have access?
			if (Game.doesInterceptWall(bot.x, bot.y, pointMap.x, pointMap.y))
			{
				pointMap = this.dronePathPoints[bot.point];
			}
			
		//On a return path
		} else {
			//Make sure point and point return are correct
			if (this.dronePathPointsOnReturn[bot.point] == undefined
				|| this.dronePathPointsOnReturn[bot.point][bot.point_return] == undefined)
			{
				Game.droneControllerDisconnectDrone(ID);
				this.moveDrone(ID);
				return true;
			}
			
			var pointMap = this.dronePathPointsOnReturn[bot.point][bot.point_return];
			var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
			if (d < speed*2)
			{
				if (bot.point_return < this.dronePathPointsOnReturn[bot.point].length-1)
				{
					bot.point_return++;
				} else {
					var point, d, idToUse = null, dToUse = null, wallCheck;
					for(var key in this.dronePathPoints)
					{
						point = this.dronePathPoints[key];
						
						d = Math.sqrt((point.x - bot.x)*(point.x - bot.x) + (point.y - bot.y)*(point.y - bot.y));
						if (idToUse == null || d < dToUse)
						{
							wallCheck = Game.doesInterceptWall(bot.x, bot.y, point.x, point.y);
							if (!wallCheck)
							{
								idToUse = key;
								dToUse = d;
							}
						}
					}
					
					idToUse = parseInt(idToUse);
					bot.point = idToUse;
					var newpoint = bot.point - bot.direction;
					if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
					else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
					bot.point = newpoint;
					delete bot.point_return;
					bot.pointAccess = "direct";
				}
				
				this.moveDrone(ID);
				return true;
			}
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 200, eObj, _d, wallCheck;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (pathType == "onreturn") pois = [-2];
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			var eTempObj = enemies[bot.enemyLockOn];
			//Make sure still have direct access
			if (eTempObj && !Game.doesInterceptWall(bot.x, bot.y, eTempObj.x, eTempObj.y))
				eIDtoUse = bot.enemyLockOn;
			else delete bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							wallCheck = Game.doesInterceptWall(bot.x, bot.y, eObj.x, eObj.y);
							if (!wallCheck)
							{
								eIDtoUse = eID;
								eDtoUse = _d;
							}
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						wallCheck = Game.doesInterceptWall(bot.x, bot.y, poiEntry.x, poiEntry.y);
						if (!wallCheck)
						{
							poiToUse = poi;
							poiToUseD = _d;
						}
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					delete bot.point_return;
					bot.pointAccess = "direct";
					pointMap = this.dronePathPoints[poi];
					
				//Find a return path
				} else {
					Game.droneControllerDisconnectDrone(ID);
					this.moveDrone(ID);
					return true;
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
	
	
	//Missile Silo Create Data
	this.missilesilo_createAction = function(ID)
	{
		var bot = Game.bots[ID];
		
		bot.crosshair.x = bot.x;
		bot.crosshair.y = Render.tvHeight*0.2;
		bot.crosshairAutoSpeed = 2.5;
		
		var ranges = [{
			x: -250,
			y: Render.tvHeight*0.31
		}, {
			x: -150,
			y: Render.tvHeight*0.26
		}, {
			x: -50,
			y: Render.tvHeight*0.22
		}, {
			x: 0,
			y: Render.tvHeight*0.2
		}, {
			x: 50,
			y: Render.tvHeight*0.22
		}, {
			x: 150,
			y: Render.tvHeight*0.26
		}, {
			x: 250,
			y: Render.tvHeight*0.31
		}];
		bot.crosshairAutoIndex = Math.ceil(ranges.length/2)-1;
		bot.crosshairAutoRange = [];
		for(var key in ranges)
		{
			bot.crosshairAutoRange.push({x: bot.x+ranges[key].x, y: ranges[key].y});
		}
	};
};
var MapAMS2 = new MapAMS2();