function MapAMS6()
{
	this.map = "ams6";
	this.base = [{
		x: Render.trueWidth*0.45,	x2: 0,
		y: Render.trueHeight*0.53,y2: 0,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 50,
		maxLife: 50,
		shield: 0, shieldUse: 0
	}, {
		x: Render.trueWidth*0.71,	x2: 0,
		y: Render.trueHeight*0.37,y2: 0,
		r: 100/2,				r2: (100/2)*Render.gp0RenderRatio,
		life: 50,
		maxLife: 50,
		shield: 0, shieldUse: 0
	}];
	this.storeRules = {
		drone: {createData:{movespeed: 4.0}}
	};
	this.walls = [];
	this.walls2 = [
		[{
			x: 0,
			y: Render.trueHeight*0.77
		}, {
			x: Render.trueWidth*0.10,
			y: Render.trueHeight*0.79
		}, {
			x: Render.trueWidth*0.4,
			y: Render.trueHeight*0.9
		}, {
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.9
		}, {
			x: Render.trueWidth*0.7,
			y: Render.trueHeight*0.85
		}, {
			x: Render.trueWidth*0.75,
			y: Render.trueHeight*0.87
		}, {
			x: Render.trueWidth*0.81,
			y: Render.trueHeight*0.915
		}, {
			x: Render.trueWidth*0.89,
			y: Render.trueHeight
		}, {
			x: 0,
			y: Render.trueHeight
		}],
		
		[{
			x: Render.trueWidth,
			y: Render.trueHeight*0.83
		}, {
			x: Render.trueWidth*0.91525,
			y: Render.trueHeight*0.7775
		}, {
			x: Render.trueWidth*0.85,
			y: Render.trueHeight*0.70
		}, {
			x: Render.trueWidth*0.8375,
			y: Render.trueHeight*0.6225
		}, {
			x: Render.trueWidth*0.85,
			y: Render.trueHeight*0.58
		}, {
			x: Render.trueWidth*0.88,
			y: Render.trueHeight*0.5
		}, {
			x: Render.trueWidth*0.95,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.9475,
			y: Render.trueHeight*0.2575
		}, {
			x: Render.trueWidth*0.91,
			y: Render.trueHeight*0.23
		}, {
			x: Render.trueWidth*0.9,
			y: Render.trueHeight*0.16
		}, {
			x: Render.trueWidth*0.92,
			y: Render.trueHeight*0.09
		}, {
			x: Render.trueWidth*0.9,
			y: 0
		}, {
			x: Render.trueWidth,
			y: 0
		}],
		
		[{
			x: Render.trueWidth*0.8,
			y: 0
		}, {
			x: Render.trueWidth*0.79,
			y: Render.trueHeight*0.09
		}, {
			x: Render.trueWidth*0.7,
			y: Render.trueHeight*0.095
		}, {
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.075
		}, {
			x: Render.trueWidth*0.6,
			y: Render.trueHeight*0.085
		}, {
			x: Render.trueWidth*0.565,
			y: Render.trueHeight*0.084
		}, {
			x: Render.trueWidth*0.55,
			y: 0
		}],
		
		[{
			x: 0,
			y: Render.trueHeight*0.29
		}, {
			x: Render.trueWidth*0.09,
			y: Render.trueHeight*0.31
		}, {
			x: Render.trueWidth*0.23,
			y: Render.trueHeight*0.15
		}, {
			x: Render.trueWidth*0.32,
			y: Render.trueHeight*0.13
		}, {
			x: Render.trueWidth*0.365,
			y: Render.trueHeight*0.14
		}, {
			x: Render.trueWidth*0.4156,
			y: Render.trueHeight*0.096
		}, {
			x: Render.trueWidth*0.435,
			y: 0
		}, {
			x: 0,
			y: 0
		}],
		
		[{
			x: 0,
			y: Render.trueHeight*0.39
		}, {
			x: Render.trueWidth*0.095,
			y: Render.trueHeight*0.41
		}, {
			x: Render.trueWidth*0.21,
			y: Render.trueHeight*0.40
		}, {
			x: Render.trueWidth*0.235,
			y: Render.trueHeight*0.45
		}, {
			x: Render.trueWidth*0.22,
			y: Render.trueHeight*0.5525
		}, {
			x: Render.trueWidth*0.305,
			y: Render.trueHeight*0.56
		}, {
			x: Render.trueWidth*0.32,
			y: Render.trueHeight*0.615
		}, {
			x: Render.trueWidth*0.285,
			y: Render.trueHeight*0.66
		}, {
			x: Render.trueWidth*0.03,
			y: Render.trueHeight*0.595
		}, {
			x: 0,
			y: Render.trueHeight*0.61
		}],
		
		[{
			x: Render.trueWidth*0.345,
			y: Render.trueHeight*0.32
		}, {
			x: Render.trueWidth*0.405,
			y: Render.trueHeight*0.61
		}, {
			x: Render.trueWidth*0.5425,
			y: Render.trueHeight*0.7
		}, {
			x: Render.trueWidth*0.55,
			y: Render.trueHeight*0.65
		}, {
			x: Render.trueWidth*0.435,
			y: Render.trueHeight*0.5425
		}, {
			x: Render.trueWidth*0.4,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.35,
			y: Render.trueHeight*0.32
		}],
		
		[{
			x: Render.trueWidth*0.49,
			y: Render.trueHeight*0.23
		}, {
			x: Render.trueWidth*0.74,
			y: Render.trueHeight*0.25
		}, {
			x: Render.trueWidth*0.78,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.745,
			y: Render.trueHeight*0.605
		}, {
			x: Render.trueWidth*0.705,
			y: Render.trueHeight*0.585
		}, {
			x: Render.trueWidth*0.73,
			y: Render.trueHeight*0.36
		}, {
			x: Render.trueWidth*0.71,
			y: Render.trueHeight*0.34
		}, {
			x: Render.trueWidth*0.55,
			y: Render.trueHeight*0.32
		}, {
			x: Render.trueWidth*0.52,
			y: Render.trueHeight*0.3
		}]
	];
	this.dronePathPoints = [{
		x: Render.trueWidth*0.5, y: Render.trueHeight*0.15
	}, {
		x: Render.trueWidth*0.65, y: Render.trueHeight*0.17
	}, {
		x: Render.trueWidth*0.83, y: Render.trueHeight*0.22
	}, {
		x: Render.trueWidth*0.85, y: Render.trueHeight*0.3
	}, {
		x: Render.trueWidth*0.8, y: Render.trueHeight*0.75
	}, {
		x: Render.trueWidth*0.45, y: Render.trueHeight*0.78
	}, {
		x: Render.trueWidth*0.4, y: Render.trueHeight*0.7
	}, {
		x: Render.trueWidth*0.3, y: Render.trueHeight*0.25
	}];
	this.dronePathPointsOnReturn = [
		[{
			x: Render.trueWidth*0.1,
			y: Render.trueHeight*0.7
		}, {
			x: Render.trueWidth*0.3,
			y: Render.trueHeight*0.78
		}],
		
		[{
			x: Render.trueWidth*0.05,
			y: Render.trueHeight*0.36
		}, {
			x: Render.trueWidth*0.1,
			y: Render.trueHeight*0.38
		}, {
			x: Render.trueWidth*0.2,
			y: Render.trueHeight*0.36
		}],
		
		[{
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.52
		}, {
			x: Render.trueWidth*0.44,
			y: Render.trueHeight*0.22
		}],
		
		[{
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.45
		}, {
			x: Render.trueWidth*0.65,
			y: Render.trueHeight*0.72
		}]
	];
	
	this.enemyPathsShown = false;
	this.enemyPaths = [{
		speed: 5.25,
		base: 1,
		color: "red",
		path: [{
			x: -50,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.12,
			y: Render.trueHeight*0.38
		}, {
			x: Render.trueWidth*0.25,
			y: Render.trueHeight*0.32
		}, {
			x: Render.trueWidth*0.42,
			y: Render.trueHeight*0.23
		}, {
			x: Render.trueWidth*0.48,
			y: Render.trueHeight*0.46
		}, {
			x: this.base[1].x,
			y: this.base[1].y
		}]
	}, {
		speed: 5.5,
		base: 0,
		color: "blue",
		path: [{
			x: -50,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.12,
			y: Render.trueHeight*0.38
		}, {
			x: Render.trueWidth*0.23,
			y: Render.trueHeight*0.35
		}, {
			x: Render.trueWidth*0.46,
			y: Render.trueHeight*0.8
		}, {
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.68
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.0,
		base: 0,
		color: "green",
		path: [{
			x: -50,
			y: Render.trueHeight*0.68
		}, {
			x: Render.trueWidth*0.4,
			y: Render.trueHeight*0.8
		}, {
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.71
		}, {
			x: Render.trueWidth*0.56,
			y: Render.trueHeight*0.55
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 6.0,
		base: 1,
		color: "yellow",
		path: [{
			x: -50,
			y: Render.trueHeight*0.68
		}, {
			x: Render.trueWidth*0.4,
			y: Render.trueHeight*0.8
		}, {
			x: Render.trueWidth*0.3,
			y: Render.trueHeight*0.28
		}, {
			x: Render.trueWidth*0.45,
			y: Render.trueHeight*0.24
		}, {
			x: Render.trueWidth*0.54,
			y: Render.trueHeight*0.4
		}, {
			x: this.base[1].x,
			y: this.base[1].y
		}]
	}, {
		speed: 6.0,
		base: 1,
		color: "purple",
		path: [{
			x: Render.trueWidth*0.5,
			y: -50
		}, {
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.18
		}, {
			x: Render.trueWidth*0.27,
			y: Render.trueHeight*0.3
		}, {
			x: Render.trueWidth*0.41,
			y: Render.trueHeight*0.79
		}, {
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.71
		}, {
			x: this.base[1].x,
			y: this.base[1].y
		}]
	}, {
		speed: 5.5,
		base: 0,
		color: "white",
		path: [{
			x: Render.trueWidth*0.85,
			y: -50
		}, {
			x: Render.trueWidth*0.85,
			y: Render.trueHeight*0.18
		}, {
			x: Render.trueWidth*0.5,
			y: Render.trueHeight*0.18
		}, {
			x: Render.trueWidth*0.43,
			y: Render.trueHeight*0.22
		}, {
			x: Render.trueWidth*0.45,
			y: Render.trueHeight*0.4
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 5.5,
		base: 0,
		color: "teal",
		path: [{
			x: Render.trueWidth*0.85,
			y: -50
		}, {
			x: Render.trueWidth*0.85,
			y: Render.trueHeight*0.4
		}, {
			x: Render.trueWidth*0.8,
			y: Render.trueHeight*0.75
		}, {
			x: Render.trueWidth*0.6,
			y: Render.trueHeight*0.6
		}, {
			x: this.base[0].x,
			y: this.base[0].y
		}]
	}, {
		speed: 5.25,
		base: 1,
		color: "orange",
		path: [{
			x: Render.trueWidth+50,
			y: Render.trueHeight+50
		}, {
			x: Render.trueWidth*0.66,
			y: Render.trueHeight*0.71
		}, {
			x: this.base[1].x,
			y: this.base[1].y
		}]
	}];
	
	//Init
	this.init = function(options)
	{
		if (options == undefined) options = {};
		if (options.mode == undefined) options.mode = Game.mode;
		
		ClickBank.clearAll();
		InputBank.clearAll();
		Render.soundsStopAll();
		
		this.renderBackgroundTV = true;
		this.renderBackgroundGP0 = true;
		this.renderBackgroundGP0Cache = {};
		this.renderBackgroundTVCover = true;
		this.renderBackgroundGP0Cover = true;
		
		//Base
		this.base[0].life = this.base[0].maxLife;
		this.base[0].shield = 0;
		this.base[0].shieldUse = 0;
		this.base[1].life = this.base[1].maxLife;
		this.base[1].shield = 0;
		this.base[1].shieldUse = 0;
		var base;
		for(var key in this.base)
		{
			base = this.base[key];
			base.cache = {};
		}
		
		//Music
		if (Render.sounds["levelbg"].readyState > 0)
			Render.sounds["levelbg"].currentTime = 0;
		Render.sounds["levelbg"].play();
		
		//Game init
		Game.map = this.map;
		Game.mapClass = this;
		Game.mode = options.mode;
		Game.init({money: 350});
		
		//Spots
		var spots = [{
			x: Render.trueWidth*0.52,
			y: Render.trueHeight*0.505
		}, {
			x: Render.trueWidth*0.665,
			y: Render.trueHeight*0.43
		}, {
			x: Render.trueWidth*0.455,
			y: Render.trueHeight*0.33
		}, {
			x: Render.trueWidth*0.63,
			y: Render.trueHeight*0.65
		}, {
			x: Render.trueWidth*0.28,
			y: Render.trueHeight*0.48
		}, {
			x: Render.trueWidth*0.75,
			y: Render.trueHeight*0.75
		}];
		var spot;
		for(var key in spots)
		{
			spot = spots[key];
			gp0Cord = Game.calculateGPCords(spot.x, spot.y);
			
			Game.spotsAdd({
				x: spot.x, y: spot.y, r: 20,
				x2: gp0Cord.x2, y2: gp0Cord.y2, r2: 20*Render.gp0RenderRatio
			});
		}
		
		Render.renderControl = function(){ MapAMS6.render(); };
		
		Game.startGame();

		//Game.botsDroneAdd();
		/*Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();
		Game.botsDroneAdd();*/
		//var ID = Game.botsAdd("drone", Render.trueWidth/2, Render.trueHeight/2, Render.gp0Width/2, Render.gp0Height/2);
	};
	
	//Map Render
	this.render = function()
	{
		//Clear
		Render.renderClear("all");
		var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		//Gamepad Slice Cache Reset
		var gp0Cord = Game.calculateGPCords(0, 0);
		if (this.renderBackgroundGP0Cache.x0 == undefined || this.renderBackgroundGP0Cache.x0 != gp0Cord.x2
		 || this.renderBackgroundGP0Cache.y0 == undefined || this.renderBackgroundGP0Cache.y0 != gp0Cord.y2
		 || this.renderBackgroundGP0Cache.z0 == undefined || this.renderBackgroundGP0Cache.z0 != Render.gp0RenderRatio)
		{
			this.renderBackgroundGP0 = true;
			this.renderBackgroundGP0Cover = true;
			Game.resetGP0SliceCache = true;
			
			this.renderBackgroundGP0Cache.x0 = gp0Cord.x2;
			this.renderBackgroundGP0Cache.y0 = gp0Cord.y2;
			this.renderBackgroundGP0Cache.z0 = Render.gp0RenderRatio;
		}
		
		//Gamepad Display Move
		Render.gp0DisplayMoveStart();
		
		//Background
		this.renderBackground();
		
		//Bots
		Game.renderBots();
		
		//Render Bases
		Render.renderBases();
		
		
		//Render Walls
		/*
		cxt.globalAlpha = 0.4;
		cxt.strokeStyle = "#DDD"; gxt.strokeStyle = "#DDD";
		cxt.fillStyle = "green"; gxt.fillStyle = "#999";
		var walls, wall, gp0Cord;
		var colors = ["red", "green", "blue", "yellow", "purple", "pink", "white"];
		for(var key in this.walls)
		{
			walls = this.walls[key];
			cxt.fillStyle = colors[key];
			
			cxt.beginPath(); gxt.beginPath();
			for(var i=0,n=walls.length; i<n; i++)
			{
				wall = walls[i];
				gp0Cord = Game.calculateGPCords(wall.x, wall.y);
				
				if (i == 0)
				{
					cxt.moveTo(wall.x, wall.y);
					gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(wall.x, wall.y);
					gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
				}
				cxt.fillRect(wall.x-25, wall.y-25, 50, 50);
			}
			cxt.fill(); gxt.fill();
			cxt.stroke(); gxt.stroke();
		}
		cxt.globalAlpha = 1;
		*/
		
		/*
		var base, r, rx, ry, r2, rx2, ry2, points, point, degree, radian, gp0Cord;
		for(var key in this.base)
		{
			base = this.base[key];
			if (base.life <= 0) continue;
			gp0Cord = Game.calculateGPCords(base.r, 0, true);
			base.r2 = gp0Cord.x2;
			gp0Cord = Game.calculateGPCords(base.x, base.y);
			
			r = base.r; rx = base.x - r; ry = base.y - r;
			gp0Cord = Game.calculateGPCords(rx, ry);
			r2 = base.r2; rx2 = gp0Cord.x2; ry2 = gp0Cord.y2;
			if (base.canvas == "undefiend" || base.canvasShieldInUse != (base.shield ? true : false) || base.canvasLife != base.life || base.canvasR2 != base.r2)
			{
				points = Game.getCircleClipPoints(base.x, base.y, r, 1);
				
				var newCanvas = document.createElement("canvas"),
					newCtx = newCanvas.getContext("2d"),
					newCanvas2 = document.createElement("canvas"),
					newCtx2 = newCanvas2.getContext("2d");
				newCanvas.width = r*2;
				newCanvas.height = r*2;
				newCanvas2.width = r2*2;
				newCanvas2.height = r2*2;
				
				newCtx.fillStyle = "rgb(0, 0, 0)";
				newCtx.beginPath();
				newCtx2.fillStyle = "rgb(0, 0, 0)";
				newCtx2.beginPath();
				for(var degree in points)
				{
					point = points[degree];
					gp0Cord = Game.calculateGPCords(point.x, point.y);
					
					if (degree == 0)
					{
						newCtx.moveTo(point.x-rx, point.y-ry);
						newCtx2.moveTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
					} else {
						newCtx.lineTo(point.x-rx, point.y-ry);
						newCtx2.lineTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
					}
				}
				newCtx.fill();
				newCtx.closePath();
				newCtx2.fill();
				newCtx2.closePath();
				
			    newCtx.globalCompositeOperation = "source-in";
			    newCtx2.globalCompositeOperation = "source-in";
				
				if (base.shield > 0)
				{
					newCtx.drawImage(Render.images["base_blue"], 0, 0, r*2, r*2);
					newCtx2.drawImage(Render.images["base_blue"], 0, 0, r2*2, r2*2);
				} else {
					var p = (base.life / base.maxLife).toFixed(2);
					
					newCtx.drawImage(Render.images["base"], 0, 0, r*2, r*2);
					newCtx2.drawImage(Render.images["base"], 0, 0, r2*2, r2*2);
					if (p < 1)
					{
						var newCanvas3 = document.createElement("canvas"),
							newCtx3 = newCanvas3.getContext("2d"),
							newCanvas4 = document.createElement("canvas"),
							newCtx4 = newCanvas4.getContext("2d");
						newCanvas3.width = r*2;
						newCanvas3.height = r*2;
						newCanvas4.width = r2*2;
						newCanvas4.height = r2*2;
					    
						newCtx3.fillStyle = "rgb(0, 0, 0)";
						newCtx3.beginPath();
						newCtx4.fillStyle = "rgb(0, 0, 0)";
						newCtx4.beginPath();
						for(var degree in points)
						{
							point = points[degree];
							gp0Cord = Game.calculateGPCords(point.x, point.y);
							
							if (degree == 0)
							{
								newCtx3.moveTo(point.x-rx, point.y-ry);
								newCtx4.moveTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
							} else {
								newCtx3.lineTo(point.x-rx, point.y-ry);
								newCtx4.lineTo(gp0Cord.x2-rx2, gp0Cord.y2-ry2);
							}
						}
						newCtx3.fill();
						newCtx3.closePath();
						newCtx4.fill();
						newCtx4.closePath();
						
					    newCtx3.globalCompositeOperation = "source-in";
					    newCtx4.globalCompositeOperation = "source-in";
						
						newCtx3.drawImage(Render.images["base_red"], 0, 0, r*2, r*2);
						newCtx4.drawImage(Render.images["base_red"], 0, 0, r2*2, r2*2);
						
						
					    newCtx.globalCompositeOperation = "source-over";
					    newCtx2.globalCompositeOperation = "source-over";
						
						newCtx.globalAlpha = 1-p; newCtx2.globalAlpha = 1-p;
						newCtx.drawImage(newCanvas3, 0, 0);
						newCtx2.drawImage(newCanvas4, 0, 0);
						newCtx.globalAlpha = 1; newCtx2.globalAlpha = 1;
					}
				}
				
				cxt.drawImage(newCanvas, rx, ry);
				gxt.drawImage(newCanvas2, rx2, ry2);
				
				base.canvas = newCanvas;
				base.canvas2 = newCanvas2;
				base.canvasShieldInUse = base.shield ? true : false;
				base.canvasLife = base.life;
				base.canvasR2 = base.r2;
			} else {
				cxt.drawImage(base.canvas, rx, ry);
				gxt.drawImage(base.canvas2, rx2, ry2);
			}
		}*/
		
		//Show drone recorded path
		/*cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		
		cxt.beginPath(); gxt.beginPath();
		
		var dronePath, gp0Cord;
		for(var i=0; i<this.dronePathPoints.length; i++)
		{
			dronePath = this.dronePathPoints[i];
			gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
			
			if (i == 0)
			{
				cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
			} else {
				cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
			}
			
			cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
			cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
			gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
			cxt.fillStyle = "red"; gxt.fillStyle = "red";
		}
		dronePath = this.dronePathPoints[0];
		gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
		cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
		
		cxt.stroke(); gxt.stroke();
		
		
		cxt.strokeStyle = "yellow"; gxt.strokeStyle = "yellow";
		
		var dronePaths;
		for(var key in this.dronePathPointsOnReturn)
		{
			dronePaths = this.dronePathPointsOnReturn[key];
			
			cxt.beginPath(); gxt.beginPath();
			for(var i=0; i<dronePaths.length; i++)
			{
				dronePath = dronePaths[i];
				gp0Cord = Game.calculateGPCords(dronePath.x, dronePath.y);
				
				if (i == 0)
				{
					cxt.moveTo(dronePath.x, dronePath.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
				} else {
					cxt.lineTo(dronePath.x, dronePath.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
				}
				
				cxt.fillStyle = "#666"; gxt.fillStyle = "#666";
				cxt.fillRect(dronePath.x-10, dronePath.y-10, 20, 20);
				gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
				cxt.fillStyle = "yellow"; gxt.fillStyle = "yellow";
			}
			cxt.stroke(); gxt.stroke();
		}*/
		
		
		//Show Enemy Paths
		if (this.enemyPathsShown)
		{
			cxt.strokeStyle = "pink"; gxt.strokeStyle = "pink";
			cxt.fillStyle = "maroon"; gxt.fillStyle = "maroon";
			var points, point, point2, d;
			for(var key in this.enemyPaths)
			{
				points = this.enemyPaths[key];
				
				if (points.color != undefined)
				{
					cxt.strokeStyle = points.color; gxt.strokeStyle = points.color;
				} else {
					cxt.strokeStyle = "pink"; gxt.strokeStyle = "pink";
				}
				
				d = 0;
				cxt.beginPath(); gxt.beginPath();
				for(var i=0,n=points.path.length; i<n; i++)
				{
					point = points.path[i];
					gp0Cord = Game.calculateGPCords(point.x, point.y);
					
					if (i == 0)
					{
						cxt.moveTo(point.x, point.y); gxt.moveTo(gp0Cord.x2, gp0Cord.y2);
					} else {
						cxt.lineTo(point.x, point.y); gxt.lineTo(gp0Cord.x2, gp0Cord.y2);
						point2 = points.path[i-1];
						d += Math.sqrt((point.x - point2.x)*(point.x - point2.x) + (point.y - point2.y)*(point.y - point2.y));
					}
					
					cxt.fillRect(point.x-10, point.y-10, 20, 20);
					gxt.fillRect(gp0Cord.x2-5, gp0Cord.y2-5, 10, 10);
				}
				cxt.stroke(); gxt.stroke();
				if (points.distance == undefined && 0)
				{
					console.log(key, d);
					points.distance = d;
				}
			}
		}
		
		
		//Call Gamer Render function
		Game.render();
		
		Game.resetGP0SliceCache = false;
	};
	
	//Hanldes the render of the Background
	this.renderBackgroundTV = true;
	this.renderBackgroundGP0 = true; this.renderBackgroundGP0Cache = {};
	this.backgroundFade = []; this.lastcalltime = 0;
	this.renderBackground = function()
	{
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTV)
		{
			var cxt = Render.returnTVSliceContext(1);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["space1_60d"], x, y, _w, _h);
			this.renderBackgroundTV = false;
		}
		if (this.renderBackgroundGP0)
		{
			var gxt = Render.returnGP0SliceContext(1);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["space1_60d"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0 = false;
		}
		
		/*
		if (this.backgroundFade.length == 0)
		{
			this.lastcalltime = Date.now();
			this.backgroundFade.push({
				x: 0, y: 0,
				w: _w, h: _h,
				alpha: 0.7, startfadein: 0, inbetweendelay: 0, inbetweendelayreset: 150,
				alphaLow: 0.5, alphaHigh: 0.7, direction: -1, speed: 0.001});
		}
		
		cxt.fillStyle = "#000"; gxt.fillStyle = "#000";
		var info, mstime = Date.now() - this.lastcalltime;
		for(var key in this.backgroundFade)
		{
			info = this.backgroundFade[key];
			gp0Cord = Game.calculateGPCords(info.x, info.y);
			
			if (info.startfadein > 0)
			{
				info.startfadein -= mstime;
			} else if (info.inbetweendelay > 0) {
				info.inbetweendelay -= mstime;
			} else {
				info.alpha += info.direction*info.speed;
				if (info.alpha <= info.alphaLow || info.alpha >= info.alphaHigh)
				{
					info.direction *= -1;
					info.inbetweendelay = info.inbetweendelayreset;
				}
			}
			
			cxt.globalAlpha = info.alpha;
			gxt.globalAlpha = info.alpha;
			cxt.fillRect(info.x, info.y, info.w, info.h);
			gxt.fillRect(gp0Cord.x2, gp0Cord.y2, info.w*Render.gp0RenderRatio, info.h*Render.gp0RenderRatio);
		}
		cxt.globalAlpha = 1;
		gxt.globalAlpha = 1;*/
		
		//this.lastcalltime = Date.now();
	};
	
	//Render the background cover
	this.renderBackgroundTVCover = true; this.renderBackgroundGP0Cover = true;
	this.renderBackgroundCover = function()
	{
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		
		var x=0,y=0,x2,y2,
			_w = Render.tvWidth, _h = Render.tvHeight,
			_w2 = Render.trueWidth*Render.gp0RenderRatio, _h2 = Render.trueHeight*Render.gp0RenderRatio;
		var gp0Cord = Game.calculateGPCords(x, y);
		if (this.renderBackgroundTVCover)
		{
			var cxt = Render.returnTVSliceContext(8);
			cxt.clearRect(0, 0, Render.tvWidth, Render.tvHeight);
			cxt.drawImage(Render.images["ams6_background"], x, y, _w, _h);
			this.renderBackgroundTVCover = false;
		}
		if (this.renderBackgroundGP0Cover)
		{
			var gxt = Render.returnGP0SliceContext(8);
			gxt.clearRect(0, 0, Render.gp0Width, Render.gp0Height);
			gxt.drawImage(Render.images["ams6_background"], gp0Cord.x2, gp0Cord.y2, _w2, _h2);
			this.renderBackgroundGP0Cover = false;
		}
	};
	
	
	//Map specific spawn enemy function
	//Returns specific data, such as pattern, start position, etc
	this.spawnEnemy = function()
	{
		var data = {};
		data.pattern = Math.floor(Math.random()*this.enemyPaths.length);
		
		var pathData = this.enemyPaths[data.pattern];
		data.speed = pathData.speed;
		data.point = 0;
		data.startX = pathData.path[0].x;
		data.startY = pathData.path[0].y;
		
		data.destination = {};
		data.destination.x = pathData.path[1].x;
		data.destination.y = pathData.path[1].y;
		
		//Speed them up?
		var baseAlive = 0;
		for(var key in this.base)
			if (this.base[key].life > 0)
				baseAlive++;
		if (baseAlive == 1) data.speed *= 1.1;
		
		return data;
	};
	
	//Map specific move enemy function
	this.moveEnemy = function(ID, obj, rate)
	{
		if (rate == undefined) rate = 1;
		var pathData = this.enemyPaths[obj.pattern],
			path = pathData.path,
			pathPoint = obj.data.point,
			speed = obj.speed*rate;
		if (obj.data.point >= pathData.path.length-1) return true;
		
		var newpoint = pathPoint+1;
		var pointMap = path[newpoint];
		var d = Math.sqrt((pointMap.x - obj.x)*(pointMap.x - obj.x) + (pointMap.y - obj.y)*(pointMap.y - obj.y));
		if (d < speed*2)
		{
			obj.data.point = newpoint;
			obj.x = pointMap.x; obj.y = pointMap.y;
			this.moveEnemy(ID, obj);
			return true;
		}
		
		//On final point?
		if (newpoint == path.length-1)
		{
			if (this.base[pathData.base].life <= 0)
			{
				if (obj.data.newbaseroute == undefined)
				{
					var base, newBase = null;
					for(var key in this.base)
					{
						if (newBase != null) continue;
						
						base = this.base[key];
						if (base.life > 0) newBase = key;
					}
					obj.data.newbaseroute = parseInt(newBase);
				}
				
				pointMap = this.base[obj.data.newbaseroute];
			}
		}
		
		
		if (!pointMap) return false;
		
		//Change Destination Points
		obj.data.destination.x = pointMap.x;
		obj.data.destination.y = pointMap.y;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - obj.x), dY = Math.abs(pointMap.y - obj.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - obj.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - obj.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - obj.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - obj.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - obj.x < 0 && pointMap.y - obj.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y < 0) { ySide *= -1; }
			else if (pointMap.x - obj.x > 0 && pointMap.y - obj.y > 0) {  }
			else if (pointMap.x - obj.x < 0 && pointMap.y - obj.y > 0) { xSide *= -1; }

			//console.log(dX, dY, angleA, speed, xSide, ySide);
		}
		
		obj.x += xSide; obj.y += ySide;
	};
	
	
	//Map Sepecific spawn drone function
	//Returns spawn data, specifically the x/y
	this.spawnDrone = function()
	{
		var data = {x: 0, y: 0, direction: Math.floor(Math.random()*2) == 0 ? -1 : 1};
		var pointindex = Math.floor(Math.random()*this.dronePathPoints.length);
		data.point = pointindex;
		
		//Choose point at random
		var point = this.dronePathPoints[pointindex];
		data.x = point.x;
		data.y = point.y;
		
		//Destination
		var newpoint = data.point + data.direction;
		if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
		else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
		var pointMap = this.dronePathPoints[newpoint];
		data.destination = {};
		data.destination.x = pointMap.x;
		data.destination.y = pointMap.y;
		
		return data;
	};
	
	//Map specific move drone function
	this.moveDroneCount = 0
	this.moveDrone = function(ID, rate, fastRate, count)
	{
		if (rate == undefined) rate = 1;
		if (fastRate == undefined) fastRate = parseInt(Game.fastRate);
		if (count == undefined || isNaN(count)) count = 0;
		
		var bot = Game.bots[ID];
		var speed = bot.data.movespeed*rate*fastRate;
		var pathType = (bot.pointAccess == undefined || bot.pointAccess == "direct" ? "direct" : "onreturn");
		
		//Special check to make sure we did not enter infiniti loop
		//this.moveDroneCount++;
		if (count >= 10)
		{
			this.moveDroneCount = 0;
			bot.pointAccess = "direct";
			bot.point = Math.floor(Math.random()*this.dronePathPoints.length);
			return false;
		}
		
		//Direction?
		if (pathType == "direct")
		{
			var newpoint = bot.point + bot.direction;
			if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
			else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
			var pointMap = this.dronePathPoints[newpoint];
			var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
			if (d < speed*2)
			{
				bot.point = newpoint;
				this.moveDrone(ID, rate, fastRate, count+1);
				return true;
			}
			
			//Does this new point not have access?
			if (Game.doesInterceptWall(bot.x, bot.y, pointMap.x, pointMap.y))
			{
				pointMap = this.dronePathPoints[bot.point];
			}
			
		//On a return path
		} else {
			//Make sure point and point return are correct
			if (this.dronePathPointsOnReturn[bot.point] == undefined
				|| this.dronePathPointsOnReturn[bot.point][bot.point_return] == undefined)
			{
				Game.droneControllerDisconnectDrone(ID);
				this.moveDrone(ID, rate, fastRare, count+1);
				return true;
			}
			
			var pointMap = this.dronePathPointsOnReturn[bot.point][bot.point_return];
			var d = Math.sqrt((pointMap.x - bot.x)*(pointMap.x - bot.x) + (pointMap.y - bot.y)*(pointMap.y - bot.y));
			if (d < speed*2)
			{
				if (bot.point_return < this.dronePathPointsOnReturn[bot.point].length-1)
				{
					bot.point_return++;
				} else {
					var point, d, idToUse = null, dToUse = null, wallCheck;
					for(var key in this.dronePathPoints)
					{
						point = this.dronePathPoints[key];
						
						d = Math.sqrt((point.x - bot.x)*(point.x - bot.x) + (point.y - bot.y)*(point.y - bot.y));
						if (idToUse == null || d < dToUse)
						{
							wallCheck = Game.doesInterceptWall(bot.x, bot.y, point.x, point.y);
							if (!wallCheck)
							{
								idToUse = key;
								dToUse = d;
							}
						}
					}
					
					idToUse = parseInt(idToUse);
					bot.point = idToUse;
					var newpoint = bot.point - bot.direction;
					if (newpoint < 0) newpoint = this.dronePathPoints.length - 1;
					else if (newpoint > this.dronePathPoints.length-1) newpoint = 0;
					bot.point = newpoint;
					delete bot.point_return;
					bot.pointAccess = "direct";
				}
				
				this.moveDrone(ID, rate, fastRate, count+1);
				return true;
			}
		}
		
		//var cxt = Render.tvContext, gxt = Render.gp0Context;
		//cxt.fillStyle = "red"; gxt.fillStyle = "red";
		
		//Determine where to go
		var pois = [bot.point-1, bot.point, bot.point+1, -2], poi, poiEntry, dcheck = 400, eObj, _d, wallCheck;
		var enemies = Game.enemiesList, eIDtoUse = null, eDtoUse = null;
		if (pathType == "onreturn") pois = [-2];
		if (bot.enemyLockOn && enemies[bot.enemyLockOn] != undefined)
		{
			var eTempObj = enemies[bot.enemyLockOn];
			//Make sure still have direct access
			if (eTempObj && !Game.doesInterceptWall(bot.x, bot.y, eTempObj.x, eTempObj.y))
				eIDtoUse = bot.enemyLockOn;
			else delete bot.enemyLockOn;
		} else delete bot.enemyLockOn;
		if (eIDtoUse == null)
		{
			for(var key in pois)
			{
				poi = pois[key];
				if (poi != -2)
				{
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
				} else poiEntry = {x: bot.x, y: bot.y};
				
				//Check for enemies close by
				for(var eID in enemies)
				{
					eObj = enemies[eID];
					_d = Math.sqrt((eObj.x - poiEntry.x)*(eObj.x - poiEntry.x) + (eObj.y - poiEntry.y)*(eObj.y - poiEntry.y));
					if (_d <= dcheck)
					{
						_d = Math.sqrt((eObj.x - bot.x)*(eObj.x - bot.x) + (eObj.y - bot.y)*(eObj.y - bot.y));
						if (eIDtoUse == null || _d > eDtoUse)
						{
							wallCheck = Game.doesInterceptWall(bot.x, bot.y, eObj.x, eObj.y);
							if (!wallCheck)
							{
								eIDtoUse = eID;
								eDtoUse = _d;
							}
						}
					}
				}
				
				//cxt.beginPath();
				//cxt.arc(poiEntry.x, poiEntry.y, dcheck, 0, 2*Math.PI, false);
				//cxt.fill();
			}
		}
		if (eIDtoUse)
		{
			pointMap = enemies[eIDtoUse];
			bot.enemyLockOn = eIDtoUse;
			
			/*cxt.strokeStyle = "yellow";
			cxt.beginPath();
			cxt.moveTo(bot.x, bot.y);
			cxt.lineTo(pointMap.x, pointMap.y);
			cxt.stroke();*/
		} else {
			//Advance smoothly to next point
			if (bot.fireduponenemy != undefined && bot.fireduponenemy)
			{
				var poiToUse = null, poiToUseD = null;
				pois = [bot.point, bot.point+bot.direction, bot.point+bot.direction*2]; _d;
				for(var key in pois)
				{
					poi = pois[key];
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					poiEntry = this.dronePathPoints[poi];
					_d = Math.sqrt((bot.x - poiEntry.x)*(bot.x - poiEntry.x) + (bot.y - poiEntry.y)*(bot.y - poiEntry.y));
					
					if (poiToUseD == null || poiToUseD > _d)
					{
						wallCheck = Game.doesInterceptWall(bot.x, bot.y, poiEntry.x, poiEntry.y);
						if (!wallCheck)
						{
							poiToUse = poi;
							poiToUseD = _d;
						}
					}
				}
				
				bot.fireduponenemy = false;
				
				if (poiToUse !== null)
				{
					poi = poiToUse+bot.direction;
					if (poi < 0) poi = this.dronePathPoints.length - 1;
					else if (poi > this.dronePathPoints.length-1) poi = 0;
					
					bot.point = poiToUse;
					delete bot.point_return;
					bot.pointAccess = "direct";
					pointMap = this.dronePathPoints[poi];
					
				//Find a return path
				} else {
					Game.droneControllerDisconnectDrone(ID);
					this.moveDrone(ID, rate, fastRate, count+1);
					return true;
				}
			}
		}
		
		//Change Destination Points
		bot.destination.x = pointMap.x;
		bot.destination.y = pointMap.y;
		
		/*var cxt = Render.tvContext, gxt = Render.gp0Context;
		cxt.fillStyle = "red"; gxt.fillStyle = "red";
		cxt.strokeStyle = "red"; gxt.strokeStyle = "red";
		cxt.fillRect(pointMap.x-10, pointMap.y-10, 20, 20);*/
		
		//Determine if point is less then speed
		_d = Math.sqrt((bot.x - pointMap.x)*(bot.x - pointMap.x) + (bot.y - pointMap.y)*(bot.y - pointMap.y));
		if (_d < speed) speed = _d;
		if (Math.abs(speed) < 0.01) return true;
		
		//Determine x and y increases
		var dX = Math.abs(pointMap.x - bot.x), dY = Math.abs(pointMap.y - bot.y);
		var xSide = 0, ySide = 0;
		if (dX == 0 && pointMap.y - bot.y < 0) { ySide = -1*speed; }
		else if (dX == 0 && pointMap.y - bot.y > 0) { ySide = speed; }
		else if (dY == 0 && pointMap.x - bot.x < 0) { xSide = -1*speed; }
		else if (dY == 0 && pointMap.x - bot.x > 0) { xSide = speed; }
		else {
			var angleA = Math.atan(dX/dY);// * (180 / Math.PI);
			xSide = Math.abs(speed*Math.sin(angleA));
			ySide = Math.abs(speed*Math.cos(angleA));
			//xSide = (angleA/90)*speed;
			//ySide = ((90-angleA)/90)*speed;
			
			if (pointMap.x - bot.x < 0 && pointMap.y - bot.y < 0) { xSide *= -1; ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y < 0) { ySide *= -1; }
			else if (pointMap.x - bot.x > 0 && pointMap.y - bot.y > 0) {  }
			else if (pointMap.x - bot.x < 0 && pointMap.y - bot.y > 0) { xSide *= -1; }
		}
		
		bot.x += xSide; bot.y += ySide;
		var gp0Cord = Game.calculateGPCords(bot.x, bot.y);
		bot.x2 = gp0Cord.x2; bot.y2 = gp0Cord.y2;
		this.moveDroneCount = 0;
		
		/*
		var gxt = Render.gp0Context;
		gxt.fillStyle = "#FFF";
		gxt.fillRect(0, 0, 400, 200);
		gxt.font = "14px Noto Sans";
		gxt.fillStyle = "#000";
		gxt.fillText(dX, 15, 15);
		gxt.fillText(dY, 15, 35);
		gxt.fillText(xSide, 15, 55);
		gxt.fillText(ySide, 15, 75);
		gxt.fillText(bot.x, 15, 95);
		gxt.fillText(bot.y, 15, 115);*/
	};
};
var MapAMS6 = new MapAMS6();